############ TCL FILE ######################################
# USER AND DATE STAMP
############################################################

  set cam_post_dir [MOM_ask_env_var UGII_CAM_POST_DIR]
  set cam_debug_dir [MOM_ask_env_var UGII_CAM_DEBUG_DIR]
  source ${cam_post_dir}ugpost_base.tcl
 
proc MOM_before_each_add_var {} {}
proc MOM_before_each_event {} {}
 
#  source ${cam_debug_dir}mom_review.tcl
 
  MOM_set_debug_mode OFF

########## SYSTEM VARIABLE DECLARATIONS ##############
  set mom_sys_rapid_code                        "L"  
  set mom_sys_linear_code                       "L"  
  set mom_sys_circle_code(CLW)                  "C"  
  set mom_sys_circle_code(CCLW)                 "C"  
  set mom_sys_delay_code(SECONDS)               "4"  
  set mom_sys_delay_code(REVOLUTIONS)           "4"  
  set mom_sys_cutcom_plane_code(XY)             "17" 
  set mom_sys_cutcom_plane_code(ZX)             "18" 
  set mom_sys_cutcom_plane_code(YZ)             "19" 
  set mom_sys_cutcom_code(OFF)                  "40" 
  set mom_sys_cutcom_code(LEFT)                 "41" 
  set mom_sys_cutcom_code(RIGHT)                "42" 
  set mom_sys_adjust_code                       "43" 
  set mom_sys_adjust_code_minus                 "44" 
  set mom_sys_adjust_cancel_code                "49" 
  set mom_sys_unit_code(IN)                     "70" 
  set mom_sys_unit_code(MM)                     "71" 
  set mom_sys_cycle_start_code                  "79" 
  set mom_sys_cycle_off                         ""   
  set mom_sys_cycle_drill_code                  "L"  
  set mom_sys_cycle_drill_dwell_code            "L"  
  set mom_sys_cycle_drill_deep_code             "L"  
  set mom_sys_cycle_drill_break_chip_code       "L"  
  set mom_sys_cycle_tap_code                    "L"  
  set mom_sys_cycle_bore_code                   "L"  
  set mom_sys_cycle_bore_drag_code              "L"  
  set mom_sys_cycle_bore_no_drag_code           "L"  
  set mom_sys_cycle_bore_dwell_code             "L"  
  set mom_sys_cycle_bore_manual_code            "L"  
  set mom_sys_cycle_bore_back_code              "L"  
  set mom_sys_cycle_bore_manual_dwell_code      "L"  
  set mom_sys_output_code(ABSOLUTE)             " "  
  set mom_sys_output_code(INCREMENTAL)          " "  
  set mom_sys_cycle_ret_code(AUTO)              ""   
  set mom_sys_cycle_ret_code(MANUAL)            ""   
  set mom_sys_reset_code                        "92" 
  set mom_sys_feed_rate_mode_code(IPM)          "94" 
  set mom_sys_feed_rate_mode_code(IPR)          "95" 
  set mom_sys_feed_rate_mode_code(FRN)          "93" 
  set mom_sys_spindle_mode_code(SFM)            "96" 
  set mom_sys_spindle_mode_code(RPM)            "97" 
  set mom_sys_return_code                       "28" 
  set mom_sys_feed_rate_mode_code(MMPM)         "94" 
  set mom_sys_feed_rate_mode_code(MMPR)         "95" 
  set mom_sys_program_stop_code                 "0"  
  set mom_sys_optional_stop_code                "1"  
  set mom_sys_end_of_program_code               "2"  
  set mom_sys_spindle_direction_code(CLW)       "3"  
  set mom_sys_spindle_direction_code(CCLW)      "4"  
  set mom_sys_spindle_direction_code(OFF)       "5"  
  set mom_sys_tool_change_code                  "6"  
  set mom_sys_coolant_code(MIST)                "25" 
  set mom_sys_coolant_code(ON)                  "8"  
  set mom_sys_coolant_code(FLOOD)               "8"  
  set mom_sys_coolant_code(TAP)                 "8"  
  set mom_sys_coolant_code(OFF)                 "9"  
  set mom_sys_rewind_code                       "30" 
  set mom_sys_sim_cycle_drill                   "0"  
  set mom_sys_sim_cycle_drill_dwell             "0"  
  set mom_sys_sim_cycle_drill_deep              "0"  
  set mom_sys_sim_cycle_drill_break_chip        "0"  
  set mom_sys_sim_cycle_tap                     "0"  
  set mom_sys_sim_cycle_bore                    "0"  
  set mom_sys_sim_cycle_bore_drag               "0"  
  set mom_sys_sim_cycle_bore_nodrag             "0"  
  set mom_sys_sim_cycle_bore_manual             "0"  
  set mom_sys_sim_cycle_bore_dwell              "0"  
  set mom_sys_sim_cycle_bore_manual_dwell       "0"  
  set mom_sys_sim_cycle_bore_back               "0"  
  set mom_sys_cir_vector                        "Vector - Absolute Arc Center"
  set mom_sys_spindle_ranges                    "0"  
  set mom_sys_rewind_stop_code                  "\#" 
  set mom_sys_home_pos(0)                       "0"  
  set mom_sys_home_pos(1)                       "0"  
  set mom_sys_home_pos(2)                       "0"  
  set mom_sys_zero                              "0"  
  set mom_sys_opskip_block_leader               "/"  
  set mom_sys_seqnum_start                      "1"  
  set mom_sys_seqnum_incr                       "1"  
  set mom_sys_seqnum_freq                       "1"  
  set mom_sys_seqnum_max                        "9999"
  set mom_sys_leader(N)                         ""   
  set mom_sys_leader(X)                         "X"  
  set mom_sys_leader(Y)                         "Y"  
  set mom_sys_leader(Z)                         "Z"  
  set mom_sys_leader(fourth_axis)               "B"  
  set mom_sys_leader(fifth_axis)                "C"  
  set mom_sys_contour_feed_mode(LINEAR)         "MMPM"
  set mom_sys_rapid_feed_mode(LINEAR)           "MMPM"
  set mom_sys_cycle_feed_mode                   "MMPM"
  set mom_sys_feed_param(IPM,format)            "Feed_IPM"
  set mom_sys_feed_param(IPR,format)            "Feed_IPR"
  set mom_sys_feed_param(FRN,format)            "Feed_INV"
  set mom_sys_contour_feed_mode(ROTARY)         "MMPM"
  set mom_sys_contour_feed_mode(LINEAR_ROTARY)  "MMPM"
  set mom_sys_feed_param(DPM,format)            "Feed_DPM"
  set mom_sys_rapid_feed_mode(ROTARY)           "MMPM"
  set mom_sys_rapid_feed_mode(LINEAR_ROTARY)    "MMPM"
  set mom_sys_feed_param(MMPM,format)           "Feed_MMPM"
  set mom_sys_feed_param(MMPR,format)           "Feed_MMPR"
  set mom_sys_control_out                       "*"  
  set mom_sys_control_in                        ""   

####### KINEMATIC VARIABLE DECLARATIONS ##############
  set mom_kin_4th_axis_ang_offset               "0.0"
  set mom_kin_4th_axis_center_offset(0)         "0.0"
  set mom_kin_4th_axis_center_offset(1)         "0.0"
  set mom_kin_4th_axis_center_offset(2)         "0.0"
  set mom_kin_4th_axis_direction                "MAGNITUDE_DETERMINES_DIRECTION"
  set mom_kin_4th_axis_incr_switch              "OFF"
  set mom_kin_4th_axis_leader                   "B"  
  set mom_kin_4th_axis_limit_action             "Warning"
  set mom_kin_4th_axis_max_limit                "180"
  set mom_kin_4th_axis_min_incr                 "0.001"
  set mom_kin_4th_axis_min_limit                "0"  
  set mom_kin_4th_axis_plane                    "YZ" 
  set mom_kin_4th_axis_rotation                 "standard"
  set mom_kin_4th_axis_type                     "Table"
  set mom_kin_4th_axis_zero                     "0.0"
  set mom_kin_5th_axis_ang_offset               "0.0"
  set mom_kin_5th_axis_center_offset(0)         "0.0"
  set mom_kin_5th_axis_center_offset(1)         "0.0"
  set mom_kin_5th_axis_center_offset(2)         "0.0"
  set mom_kin_5th_axis_direction                "MAGNITUDE_DETERMINES_DIRECTION"
  set mom_kin_5th_axis_incr_switch              "OFF"
  set mom_kin_5th_axis_leader                   "C"  
  set mom_kin_5th_axis_limit_action             "Warning"
  set mom_kin_5th_axis_max_limit                "99999.999"
  set mom_kin_5th_axis_min_incr                 "0.001"
  set mom_kin_5th_axis_min_limit                "-99999.999"
  set mom_kin_5th_axis_plane                    "ZX" 
  set mom_kin_5th_axis_rotation                 "standard"
  set mom_kin_5th_axis_type                     "Table"
  set mom_kin_5th_axis_zero                     "0.0"
  set mom_kin_arc_output_mode                   "FULL_CIRCLE"
  set mom_kin_arc_valid_planes                  "XYZ"
  set mom_kin_clamp_time                        "2.0"
  set mom_kin_flush_time                        "2.0"
  set mom_kin_linearization_flag                "1"  
  set mom_kin_linearization_tol                 "0.001"
  set mom_kin_machine_resolution                ".001"
  set mom_kin_machine_type                      "5_axis_dual_table"
  set mom_kin_max_arc_radius                    "99999.999"
  set mom_kin_max_dpm                           "10000"
  set mom_kin_max_fpm                           "15000"
  set mom_kin_max_fpr                           "1000"
  set mom_kin_max_frn                           "1000"
  set mom_kin_min_arc_length                    "0.001"
  set mom_kin_min_arc_radius                    "0.001"
  set mom_kin_min_dpm                           "0.0"
  set mom_kin_min_fpm                           "0.1"
  set mom_kin_min_fpr                           "0.1"
  set mom_kin_min_frn                           "0.01"
  set mom_kin_output_unit                       "MM" 
  set mom_kin_pivot_gauge_offset                "0.0"
  set mom_kin_pivot_guage_offset                ""   
  set mom_kin_post_data_unit                    "MM" 
  set mom_kin_rapid_feed_rate                   "20000"
  set mom_kin_tool_change_time                  "12.0"
  set mom_kin_x_axis_limit                      "1000"
  set mom_kin_y_axis_limit                      "1000"
  set mom_kin_z_axis_limit                      "1000"

####  Listing File variables 
  set mom_sys_list_output                       "OFF"
  set mom_sys_header_output                     "OFF"
  set mom_sys_list_file_rows                    "40" 
  set mom_sys_list_file_columns                 "30" 
  set mom_sys_warning_output                    "OFF"
  set mom_sys_group_output                      "OFF"
  set mom_sys_list_file_suffix                  "lpt"
  set mom_sys_output_file_suffix                "h"  
  set mom_sys_commentary_output                 "ON" 
  set mom_sys_commentary_list                   "x y z 4axis 5axis feed speed"




#=============================================================
proc MOM_start_of_program { } {
#=============================================================
  global mom_logname mom_date is_from
  global mom_coolant_status mom_cutcom_status
  global mom_clamp_status mom_cycle_status
  global mom_spindle_status mom_cutcom_plane pb_start_of_program_flag
  global mom_cutcom_adjust_register mom_tool_adjust_register
  global mom_tool_length_adjust_register mom_length_comp_register
  global mom_flush_register mom_wire_cutcom_adjust_register

    set pb_start_of_program_flag 0
    set mom_coolant_status UNDEFINED
    set mom_cutcom_status  UNDEFINED
    set mom_clamp_status   UNDEFINED
    set mom_cycle_status   UNDEFINED
    set mom_spindle_status UNDEFINED
    set mom_cutcom_plane   UNDEFINED

    catch {unset mom_cutcom_adjust_register}
    catch {unset mom_tool_adjust_register}
    catch {unset mom_tool_length_adjust_register}
    catch {unset mom_length_comp_register}
    catch {unset mom_flush_register}
    catch {unset mom_wire_cutcom_adjust_register}

    set is_from ""

    OPEN_files ; #open warning and listing files
    LIST_FILE_HEADER ; #list header in commentary listing
}


#=============================================================
proc PB_DELAY_TIME_SET { } {
#=============================================================
  global mom_sys_delay_param mom_delay_value
  global mom_delay_revs mom_delay_mode delay_time

   # post builder provided format for the current mode:
    if {[info exists mom_sys_delay_param(${mom_delay_mode},format)] != 0} {
      MOM_set_address_format dwell $mom_sys_delay_param(${mom_delay_mode},format)
    }

    switch $mom_delay_mode {
      SECONDS {set delay_time $mom_delay_value}
      default {set delay_time $mom_delay_revs}
    }
}


#=============================================================
proc MOM_before_motion { } {
#=============================================================
  global mom_motion_event mom_motion_type

    FEEDRATE_SET


    switch $mom_motion_type {
      ENGAGE   {PB_engage_move}
      APPROACH {PB_approach_move}
      FIRSTCUT {PB_first_cut}
    }

    if [llength [info commands PB_CMD_kin_before_motion] ] { PB_CMD_kin_before_motion }
    if [llength [info commands PB_CMD_before_motion] ]     { PB_CMD_before_motion }
}


#=============================================================
proc MOM_start_of_group {} {
#=============================================================
  global mom_sys_group_output mom_group_name group_level ptp_file_name
  global mom_sequence_number mom_sequence_increment mom_sequence_frequency
  global mom_sys_ptp_output pb_start_of_program_flag

    if {[regexp NC_PROGRAM $mom_group_name] == 1} {set group_level 0 ; return}

    if {[hiset mom_sys_group_output]} { if {$mom_sys_group_output == "OFF"} {set group_level 0 ; return}}
    if {[hiset group_level]} {incr group_level} else {set group_level 1}
    if {$group_level > 1} {return}

    SEQNO_RESET ; #<4133654>
    MOM_reset_sequence $mom_sequence_number $mom_sequence_increment $mom_sequence_frequency

    if {[info exists ptp_file_name]} {
      MOM_close_output_file $ptp_file_name ; MOM_start_of_program
      if {$mom_sys_ptp_output == "ON"} {MOM_open_output_file $ptp_file_name }
    } else {
      MOM_start_of_program
    }

    PB_start_of_program ; set pb_start_of_program_flag 1
}


#=============================================================
proc MOM_machine_mode {} {
#=============================================================
  global pb_start_of_program_flag
  global mom_operation_name mom_sys_change_mach_operation_name

   set mom_sys_change_mach_operation_name $mom_operation_name

    if {$pb_start_of_program_flag == 0} {PB_start_of_program ; set pb_start_of_program_flag 1}
    catch {PB_CMD_machine_mode}
}


#=============================================================
proc PB_FORCE { option args } {
#=============================================================
   if { [info exists option] && [llength $args] } {
      lappend cmd MOM_force
      lappend cmd $option
      lappend cmd [join $args]
      eval { join $cmd }
   }
}


#=============================================================
proc PB_SET_RAPID_MOD { mod_list blk_list ADDR NEW_MOD_LIST } {
#=============================================================
  upvar $ADDR addr
  upvar $NEW_MOD_LIST new_mod_list
  global mom_cycle_spindle_axis traverse_axis1 traverse_axis2


   set new_mod_list [list]

   foreach mod $mod_list {
      switch $mod {
         "rapid1" {
            set elem $addr($traverse_axis1)
            if { [lsearch $blk_list $elem] >= 0 } {
               lappend new_mod_list $elem
            }
         }
         "rapid2" {
            set elem $addr($traverse_axis2)
            if { [lsearch $blk_list $elem] >= 0 } {
               lappend new_mod_list $elem
            }
         }
         "rapid3" {
            set elem $addr($mom_cycle_spindle_axis)
            if { [lsearch $blk_list $elem] >= 0 } {
               lappend new_mod_list $elem
            }
         }
         default {
            set elem $mod
            if { [lsearch $blk_list $elem] >= 0 } {
               lappend new_mod_list $elem
            }
         }
      }
   }
}


########################
# Redefine FEEDRATE_SET
########################
if [llength [info commands ugpost_FEEDRATE_SET] ] {
   rename ugpost_FEEDRATE_SET ""
}

if [llength [info commands FEEDRATE_SET] ] {
   rename FEEDRATE_SET ugpost_FEEDRATE_SET
} else {
   proc ugpost_FEEDRATE_SET {} {}
}


#=============================================================
proc FEEDRATE_SET {} {
#=============================================================
   if [llength [info commands PB_CMD_kin_feedrate_set] ] {
      PB_CMD_kin_feedrate_set
   } else {
      ugpost_FEEDRATE_SET
   }
}


############## EVENT HANDLING SECTION ################


#=============================================================
proc PB_start_of_program { } {
#=============================================================

   if [llength [info commands PB_CMD_kin_start_of_program] ] {
      PB_CMD_kin_start_of_program
   }

   PB_CMD_set_initial_MSYS
   PB_CMD_init_helix
   PB_CMD_SIM_init
   PB_CMD_init_vars
   PB_CMD_force_motion_addresses
   MOM_set_seq_off
   PB_CMD_post_name
   PB_CMD_program_name_set
   MOM_do_template start_of_program
   MOM_set_seq_on
   MOM_do_template blank_form_1
   MOM_do_template blank_form_2
   MOM_do_template datum_shift_def
   MOM_do_template datum_sel
   MOM_do_template label_call_table_flat
   MOM_do_template table_abs_zero
   MOM_do_template cond_jump
}


#=============================================================
proc MOM_start_of_path { } {
#=============================================================
  global first_linear_move ; set first_linear_move 0
   TOOL_SET MOM_start_of_path

   if [llength [info commands PB_CMD_kin_start_of_path] ] {
      PB_CMD_kin_start_of_path
   }

   PB_CMD_start_of_operation_force_addresses
}


#=============================================================
proc MOM_from_move { } {
#=============================================================
  global mom_feed_rate mom_feed_rate_per_rev  mom_motion_type mom_kin_max_fpm
   COOLANT_SET ; CUTCOM_SET ; SPINDLE_SET ; RAPID_SET
}


#=============================================================
proc MOM_first_tool { } {
#=============================================================
  global mom_tool_change_type mom_manual_tool_change
   if {[info exists mom_tool_change_type]} {
      switch $mom_tool_change_type {
         MANUAL { PB_manual_tool_change }
         AUTO   { PB_auto_tool_change }
      }
   } elseif {[info exists mom_manual_tool_change]} {
      if {$mom_manual_tool_change == "TRUE"} {
         PB_manual_tool_change
      }
   }
}


#=============================================================
proc PB_auto_tool_change { } {
#=============================================================
   PB_CMD_call_probe_cycle
   PB_CMD_tool_init
   MOM_force Once Text T Text S
   MOM_do_template tool_change_1
   PB_CMD_error_tool_number
   PB_CMD_SIM_tool_change
}


#=============================================================
proc PB_manual_tool_change { } {
#=============================================================
   MOM_do_template stop
}


#=============================================================
proc MOM_initial_move { } {
#=============================================================
  global mom_feed_rate mom_feed_rate_per_rev mom_motion_type
  global mom_kin_max_fpm mom_motion_event
   COOLANT_SET ; CUTCOM_SET ; SPINDLE_SET ; RAPID_SET
   PB_CMD_init_multi_axis
   PB_CMD_start_of_operation_motion

  global mom_programmed_feed_rate
   if { [EQ_is_equal $mom_programmed_feed_rate 0] } {
      MOM_rapid_move
   } else {
      MOM_linear_move
   }
}


#=============================================================
proc MOM_first_move { } {
#=============================================================
  global mom_feed_rate mom_feed_rate_per_rev mom_motion_type
  global mom_kin_max_fpm mom_motion_event
   COOLANT_SET ; CUTCOM_SET ; SPINDLE_SET ; RAPID_SET
   PB_CMD_init_multi_axis
   PB_CMD_start_of_operation_motion
   catch {MOM_$mom_motion_event}
}


#=============================================================
proc PB_approach_move { } {
#=============================================================
}


#=============================================================
proc PB_engage_move { } {
#=============================================================
}


#=============================================================
proc PB_first_cut { } {
#=============================================================
}


#=============================================================
proc PB_first_linear_move { } {
#=============================================================
}


#=============================================================
proc PB_return_move { } {
#=============================================================
}


#=============================================================
proc MOM_gohome_move { } {
#=============================================================
   MOM_rapid_move
}


#=============================================================
proc MOM_end_of_path { } {
#=============================================================

   if [llength [info commands PB_CMD_kin_end_of_path] ] {
      PB_CMD_kin_end_of_path
   }

   PB_CMD_M129
}


#=============================================================
proc MOM_end_of_program { } {
#=============================================================
   PB_CMD_call_probe_cycle
   MOM_do_template end_of_program_2
   MOM_output_literal "*150 # Breuk tool = Einde Programma"
   MOM_do_template end_of_program
   PB_CMD_default_labels_output
   PB_CMD_write_stored_work_planes
   MOM_do_template end_of_program_1
   PB_CMD_error_report_to_screen

#**** The following procedure lists the tool list with time in commentary data
   LIST_FILE_TRAILER

#**** The following procedure closes the warning and listing files
   CLOSE_files
}


#=============================================================
proc MOM_tool_change { } {
#=============================================================
  global mom_tool_change_type mom_manual_tool_change
   if {[info exists mom_tool_change_type]} {
      switch $mom_tool_change_type {
         MANUAL { PB_manual_tool_change }
         AUTO   { PB_auto_tool_change }
      }
   } elseif {[info exists mom_manual_tool_change]} {
      if {$mom_manual_tool_change == "TRUE"} {
         PB_manual_tool_change
      }
   }
}


#=============================================================
proc MOM_length_compensation { } {
#=============================================================
   TOOL_SET MOM_length_compensation
   MOM_do_template tool_length_adjust
}


#=============================================================
proc MOM_set_modes { } {
#=============================================================
   MODES_SET
}


#=============================================================
proc MOM_spindle_rpm { } {
#=============================================================
   SPINDLE_SET
   MOM_force Once S M_spindle
   MOM_do_template spindle_rpm
}


#=============================================================
proc MOM_spindle_off { } {
#=============================================================
   MOM_do_template spindle_off
}


#=============================================================
proc MOM_coolant_on { } {
#=============================================================
   COOLANT_SET
}


#=============================================================
proc MOM_coolant_off { } {
#=============================================================
   COOLANT_SET
   MOM_do_template coolant_off
}


#=============================================================
proc PB_feedrates { } {
#=============================================================
}


#=============================================================
proc MOM_cutcom_on { } {
#=============================================================
   CUTCOM_SET
}


#=============================================================
proc MOM_cutcom_off { } {
#=============================================================
   CUTCOM_SET
   MOM_do_template cutcom_off
}


#=============================================================
proc MOM_delay { } {
#=============================================================
   PB_DELAY_TIME_SET
   MOM_do_template delay
}


#=============================================================
proc MOM_opstop { } {
#=============================================================
   MOM_do_template opstop
}


#=============================================================
proc MOM_auxfun { } {
#=============================================================
   MOM_do_template auxfun
}


#=============================================================
proc MOM_prefun { } {
#=============================================================
   MOM_do_template prefun
}


#=============================================================
proc MOM_load_tool { } {
#=============================================================
  global mom_tool_change_type mom_manual_tool_change
}


#=============================================================
proc MOM_stop { } {
#=============================================================
   MOM_do_template stop
}


#=============================================================
proc MOM_tool_preselect { } {
#=============================================================
  global mom_tool_preselect_number mom_tool_number mom_next_tool_number
   if {[info exists mom_tool_preselect_number]} {
      set mom_next_tool_number $mom_tool_preselect_number
   }
   MOM_do_template tool_preselect
}


#=============================================================
proc MOM_linear_move { } {
#=============================================================
  global feed_mode mom_feed_rate mom_kin_rapid_feed_rate

   if { $feed_mode == "IPM" || $feed_mode == "MMPM" } {
      if { [EQ_is_ge $mom_feed_rate $mom_kin_rapid_feed_rate] } {
         MOM_rapid_move ; return
      }
   }

  global first_linear_move

   if {!$first_linear_move} { PB_first_linear_move ; incr first_linear_move }

   MOM_force Once G_motion
   MOM_do_template linear_move_1
   PB_CMD_SIM_linear_move
}


#=============================================================
proc MOM_circular_move { } {
#=============================================================
   CIRCLE_SET
   PB_CMD_activate_circle_center
   MOM_force Once Text
   MOM_do_template circular_move
   PB_CMD_circle_direction
   MOM_force Once G_motion circle_direction
   MOM_do_template circular_move_1
   PB_CMD_SIM_circular_move
}


#=============================================================
proc MOM_rapid_move { } {
#=============================================================
  global rapid_spindle_inhibit rapid_traverse_inhibit
  global spindle_first is_from
  global mom_cycle_spindle_axis traverse_axis1 traverse_axis2
  global mom_motion_event

   set aa(0) X ; set aa(1) Y ; set aa(2) Z
   RAPID_SET
   set rapid_traverse_blk {G_motion X Y Z fourth_axis fifth_axis cutter_comp Text M_spindle M_coolant}
   set rapid_traverse_mod {G_motion Text}
   PB_SET_RAPID_MOD $rapid_traverse_mod $rapid_traverse_blk aa mod_traverse
   PB_FORCE Once $mod_traverse
   MOM_do_template rapid_traverse
   PB_CMD_SIM_rapid_xyz
   PB_CMD_save_last_z
}


#=============================================================
proc MOM_cycle_off { } {
#=============================================================
}


#=============================================================
proc MOM_cycle_plane_change { } {
#=============================================================
  global cycle_init_flag

   set cycle_init_flag TRUE
   PB_CMD_cycle_plane_change
   set cycle_init_flag FALSE
}


#=============================================================
proc MOM_drill { } {
#=============================================================
  global cycle_name
  global cycle_init_flag

   set cycle_init_flag TRUE
   set cycle_name DRILL
   CYCLE_SET
}


#=============================================================
proc MOM_drill_move { } {
#=============================================================
  global cycle_init_flag

   PB_CMD_cycle_init
   MOM_force Once X Y
   MOM_do_template cycle_drill
   MOM_do_template cycle_parameters
   PB_CMD_SIM_cycle_move
   set cycle_init_flag FALSE
}


#=============================================================
proc MOM_drill_dwell { } {
#=============================================================
  global cycle_name
  global cycle_init_flag

   set cycle_init_flag TRUE
   set cycle_name DRILL_DWELL
   CYCLE_SET
}


#=============================================================
proc MOM_drill_dwell_move { } {
#=============================================================
  global cycle_init_flag

   PB_CMD_cycle_init
   MOM_force Once X Y
   MOM_do_template cycle_drill_dwell
   MOM_do_template cycle_parameters
   PB_CMD_SIM_cycle_move
   set cycle_init_flag FALSE
}


#=============================================================
proc MOM_drill_deep { } {
#=============================================================
  global cycle_name
  global cycle_init_flag

   set cycle_init_flag TRUE
   set cycle_name DRILL_DEEP
   CYCLE_SET
}


#=============================================================
proc MOM_drill_deep_move { } {
#=============================================================
  global cycle_init_flag

   PB_CMD_cycle_init
   MOM_force Once X Y
   MOM_do_template cycle_drill_deep
   MOM_do_template cycle_parameters
   PB_CMD_SIM_cycle_move
   set cycle_init_flag FALSE
}


#=============================================================
proc MOM_drill_break_chip { } {
#=============================================================
  global cycle_name
  global cycle_init_flag

   set cycle_init_flag TRUE
   set cycle_name DRILL_BREAK_CHIP
   CYCLE_SET
}


#=============================================================
proc MOM_drill_break_chip_move { } {
#=============================================================
  global cycle_init_flag

   PB_CMD_cycle_init
   MOM_force Once X Y
   MOM_do_template cycle_drill_break_chip
   MOM_do_template cycle_parameters
   PB_CMD_SIM_cycle_move
   set cycle_init_flag FALSE
}


#=============================================================
proc MOM_tap { } {
#=============================================================
  global cycle_name
  global cycle_init_flag

   set cycle_init_flag TRUE
   set cycle_name TAP
   CYCLE_SET
}


#=============================================================
proc MOM_tap_move { } {
#=============================================================
  global cycle_init_flag

   PB_CMD_cycle_init
   MOM_force Once X Y
   MOM_do_template cycle_tap
   MOM_do_template cycle_parameters
   PB_CMD_SIM_cycle_move
   set cycle_init_flag FALSE
}


#=============================================================
proc MOM_bore { } {
#=============================================================
  global cycle_name
  global cycle_init_flag

   set cycle_init_flag TRUE
   set cycle_name BORE
   CYCLE_SET
}


#=============================================================
proc MOM_bore_move { } {
#=============================================================
  global cycle_init_flag

   PB_CMD_cycle_init
   MOM_force Once X Y
   MOM_do_template cycle_bore
   MOM_do_template cycle_parameters
   PB_CMD_SIM_cycle_move
   set cycle_init_flag FALSE
}


#=============================================================
proc MOM_bore_drag { } {
#=============================================================
  global cycle_name
  global cycle_init_flag

   set cycle_init_flag TRUE
   set cycle_name BORE_DRAG
   CYCLE_SET
}


#=============================================================
proc MOM_bore_drag_move { } {
#=============================================================
  global cycle_init_flag

   PB_CMD_cycle_init
   MOM_force Once X Y
   MOM_do_template cycle_bore_drag
   PB_CMD_error_unsupported_cycle
   MOM_do_template cycle_parameters
   PB_CMD_SIM_cycle_move
   set cycle_init_flag FALSE
}


#=============================================================
proc MOM_bore_no_drag { } {
#=============================================================
  global cycle_name
  global cycle_init_flag

   set cycle_init_flag TRUE
   set cycle_name BORE_NO_DRAG
   CYCLE_SET
}


#=============================================================
proc MOM_bore_no_drag_move { } {
#=============================================================
  global cycle_init_flag

   PB_CMD_cycle_init
   MOM_force Once X Y
   MOM_do_template cycle_bore_no_drag
   MOM_do_template cycle_parameters
   PB_CMD_SIM_cycle_move
   set cycle_init_flag FALSE
}


#=============================================================
proc MOM_bore_manual { } {
#=============================================================
  global cycle_name
  global cycle_init_flag

   set cycle_init_flag TRUE
   set cycle_name BORE_MANUAL
   CYCLE_SET
}


#=============================================================
proc MOM_bore_manual_move { } {
#=============================================================
  global cycle_init_flag

   PB_CMD_cycle_init
   MOM_force Once X Y
   MOM_do_template cycle_bore_manual
   PB_CMD_error_unsupported_cycle
   MOM_do_template cycle_parameters
   PB_CMD_SIM_cycle_move
   set cycle_init_flag FALSE
}


#=============================================================
proc MOM_bore_dwell { } {
#=============================================================
  global cycle_name
  global cycle_init_flag

   set cycle_init_flag TRUE
   set cycle_name BORE_DWELL
   CYCLE_SET
}


#=============================================================
proc MOM_bore_dwell_move { } {
#=============================================================
  global cycle_init_flag

   PB_CMD_cycle_init
   MOM_force Once X Y
   MOM_do_template cycle_bore_dwell
   MOM_do_template cycle_parameters
   PB_CMD_SIM_cycle_move
   set cycle_init_flag FALSE
}


#=============================================================
proc MOM_bore_back { } {
#=============================================================
  global cycle_name
  global cycle_init_flag

   set cycle_init_flag TRUE
   set cycle_name BORE_BACK
   CYCLE_SET
}


#=============================================================
proc MOM_bore_back_move { } {
#=============================================================
  global cycle_init_flag

   PB_CMD_cycle_init
   MOM_force Once X Y
   MOM_do_template cycle_bore_back
   PB_CMD_error_unsupported_cycle
   MOM_do_template cycle_parameters
   PB_CMD_SIM_cycle_move
   set cycle_init_flag FALSE
}


#=============================================================
proc MOM_bore_manual_dwell { } {
#=============================================================
  global cycle_name
  global cycle_init_flag

   set cycle_init_flag TRUE
   set cycle_name BORE_MANUAL_DWELL
   CYCLE_SET
}


#=============================================================
proc MOM_bore_manual_dwell_move { } {
#=============================================================
  global cycle_init_flag

   PB_CMD_cycle_init
   MOM_force Once X Y
   MOM_do_template cycle_bore_manual_dwell
   PB_CMD_error_unsupported_cycle
   MOM_do_template cycle_parameters
   PB_CMD_SIM_cycle_move
   set cycle_init_flag FALSE
}


#=============================================================
proc MOM_sequence_number { } {
#=============================================================
   SEQNO_SET
}


#=============================================================
proc PB_CMD_FEEDRATE_NUMBER { } {
#=============================================================
#
#  This custom command allows you to modify the feed rate number
#  after it has been calculated by the system
#
   global mom_feed_rate_number

   set mom_sys_frn_factor 1.0

   if [info exists mom_feed_rate_number] {
      return [expr $mom_feed_rate_number * $mom_sys_frn_factor]
   } else {
      return 0.0
   }
}


#=============================================================
proc PB_CMD_Initialise_MTD { } {
#=============================================================
#
#  This custom command initialises the MTD for the DMU 50 eVolution
#  Procedure to be called in start of program
#
#  Date		Who	Description
#  24-sep-2002	GKW	Initial version
#

uplevel  {
	proc MOM_test {}  {
		MOM_output_literal "Test"
	}
}
MOM_test
}


#=============================================================
proc PB_CMD_M129 { } {
#=============================================================
# Set TCPM M128 mode off

global gkw_tpcm_mode
set gkw_tpcm_mode 129
MOM_do_template m_tpcm
}


#=============================================================
proc PB_CMD_SIM_circular_move { } {
#=============================================================
# Initiates the Cirular Move for Simulation

VNC_circular_move
}


#=============================================================
proc PB_CMD_SIM_cycle_move { } {
#=============================================================
# Initiates all cycle motions needed

VNC_rapid_xy 
VNC_do_drill_cycle
}


#=============================================================
proc PB_CMD_SIM_end_of_program { } {
#=============================================================
# End the simulation

VNC_end_of_program
}


#=============================================================
proc PB_CMD_SIM_go_home { } {
#=============================================================
VNC_rapid_home
VNC_move_rapid_bc 0 0
}


#=============================================================
proc PB_CMD_SIM_init { } {
#=============================================================
# This procedure initialises the simulation engine
# and sets the kinematics variables to define the machine axis

global sim_4th_axis sim_5th_axis
global sim_tool_change_pos sim_tool_measure_pos sim_previous_tool_number

# set here your 4th and 5th axis
  set sim_4th_axis B
  set sim_5th_axis C
  set sim_previous_tool_number 0

# Set tool change pos 

set sim_tool_change_pos(0)    -500.
set sim_tool_change_pos(1)    -305.35
set sim_tool_change_pos(2)       0.0

# Set tool measure pos

set sim_tool_measure_pos(0)   -500.83
set sim_tool_measure_pos(1)   -305.35
set sim_tool_measure_pos(2)   -430.0

#LOAD_5AXIS_KINEMATICS

PB_CMD_set_kinematics

VNC_start_of_program
}


#=============================================================
proc PB_CMD_SIM_linear_move { } {
#=============================================================
# This command executes the Linear Simulation event

VNC_linear
}


#=============================================================
proc PB_CMD_SIM_linear_move_xy { } {
#=============================================================
# This command executes the Linear Simulation event

VNC_linear_xy
}


#=============================================================
proc PB_CMD_SIM_linear_move_z { } {
#=============================================================
# This command executes the Linear Simulation event

VNC_linear_z
}


#=============================================================
proc PB_CMD_SIM_rapid_bc { } {
#=============================================================
# Simulation of Rapid B and C

VNC_rapid_bc
}


#=============================================================
proc PB_CMD_SIM_rapid_xy { } {
#=============================================================
# Initiate Rapid XY movement for Simulation

VNC_rapid_xy
}


#=============================================================
proc PB_CMD_SIM_rapid_xyz { } {
#=============================================================
# Initiate Rapid XY movement for Simulation

VNC_rapid_xyz
}


#=============================================================
proc PB_CMD_SIM_rapid_z { } {
#=============================================================
# Initiate Rapid Z movement for Simulation

VNC_rapid_z
}


#=============================================================
proc PB_CMD_SIM_tool_change { } {
#=============================================================
# Change the tool for simulation
# switch coolant on depending on coolant_status

global mom_tool_name
global mom_coolant_status

VNC_tool_change $mom_tool_name
if {$mom_coolant_status == "OFF"}  {
  VNC_coolant_off
}  else  {
  VNC_coolant_on
}
}


#=============================================================
proc PB_CMD_activate_circle_center { } {
#=============================================================
global mom_pos_arc_plane
switch $mom_pos_arc_plane {
  XY { MOM_force once I J X Y }
  YZ { MOM_force once J K Y Z }
  ZX { MOM_force once I K X Z }
}
}


#=============================================================
proc PB_CMD_before_motion { } {
#=============================================================
global mom_cutcom_status cutter_comp
global gkw_prev_tool_axis mom_tool_axis gkw_prev_mcs_goto mom_mcs_goto
global B C


if {![info exist mom_cutcom_status]} {
    set cutter_comp "R0"
} elseif {$mom_cutcom_status == "OFF"} {
    set cutter_comp "R0"
} elseif {$mom_cutcom_status == "LEFT"} {
    set cutter_comp "RL"
} elseif {$mom_cutcom_status == "RIGHT"} {
    set cutter_comp "RR"
}

PB_CMD_calculate_BC

#MOM_output_literal "B $B C $C"
# Check Axis position for custom 5-axis motion control
global C
global mom_sys_control_out mom_sys_control_in
global mom_kin_5th_axis_max_limit mom_kin_5th_axis_min_limit

if { $C > $mom_kin_5th_axis_max_limit || $C < $mom_kin_5th_axis_min_limit} {
  MOM_output_literal "$mom_sys_control_out Reset C-Axis in motion $mom_sys_control_in"
  PB_CMD_reset_c-axis
}

array set gkw_prev_tool_axis [array get mom_tool_axis]
array set gkw_prev_mcs_goto [array get mom_mcs_goto]
}


#=============================================================
proc PB_CMD_calculate_BC { } {
#=============================================================
#_______________________________________________________________________________
# This procedure is executed before each linear move.
# It calculates the B and C-axis for DMU xx V
# The values are stored in B and C
#_______________________________________________________________________________
global mom_pos
global B Bold Babs C Cold Cabs Cadd

# Store old B and C values

set Bold $B
set Cold $C

# Calculate theorethical B (Babs) and C (Cabs) angles

PB_CMD_calculate_rotary_angles

set B $Babs
# Check if B output is smaller than 0.001 (machine resolution) so C can stay in current position

if { [format "%.3f" $Babs] < 0.001 } {
  set C $Cold
} else {
  # Check if going over the 360 limit and compensate
#MOM_output_literal "C $C Cabs $Cabs Cadd $Cadd Cold $Cold"
  if { [expr $Cabs+$Cadd-$Cold] > 180 } {
    set Cadd [expr $Cadd -360]
  }
  if { [expr $Cabs+$Cadd-$Cold] < -180 } {
    set Cadd [expr $Cadd +360]
  }
  set C [expr $Cabs+$Cadd]
}
}


#=============================================================
proc PB_CMD_calculate_BC_1 { } {
#=============================================================
#_______________________________________________________________________________
# This procedure is executed before each linear move.
# It calculates the B and C-axis for DMU xx V
# The values are stored in B and C
#_______________________________________________________________________________
global mom_pos
global xi yi zi xf yf zf
global  C Cabs Cant Cinc B Bant Binc
global inc1
global num_mov
global num_pasos_lin
global tollin
global xfsave yfsave zfsave Bsave Csave Cfinal
global Cabs_antiguo
global Cold

#if {$num_mov == 0}  #{
#	MOM_do_template rapid_cl
#} 
set num_mov [expr $num_mov+1]

set xi $mom_pos(0)
set yi $mom_pos(1)
set zi $mom_pos(2)

set Cabs_old $Cabs
set Cold $C
set Cant_old $Cant
	
PB_CMD_calculate_rotary_angles
set Cfinal $C
MOM_output_literal "Cfinal $Cfinal"
# PB_CMD_transform_coord

set inc1 [expr $C - $Cant]
	
#busco el camino ms corto
if {$inc1 < -180}  {
	set Cinc  [expr 360 + $inc1]
} 

if {$inc1 > 180}  {
	set Cinc  [expr $inc1 - 360]
} 
        
if {$inc1 > -180 && $inc1 < 180}  {
	set Cinc $inc1
}
	        
	
set Cabs [expr $Cabs + $Cinc]
set Binc  [expr $B - $Bant]

set Cant $Cfinal
set Cabs_antiguo $Cabs
set Bant $B

if {[expr abs($B)] < 0.0005}  {
	set Cabs $Cabs_old
	set C $Cold
	set Cant $Cant_old
}
MOM_output_literal "[format "C %3.2f Cant %3.2f Cinc %3.2f Cabs %3.2f Cfinal %3.2f" $C $Cant $Cinc $Cabs $Cfinal]"
}


#=============================================================
proc PB_CMD_calculate_alpha { } {
#=============================================================
#_______________________________________________________________________________
# para obtener el angulo conociendo las coordenadas x e y(ij). "A" es el mdulo del vector
#
#_______________________________________________________________________________
global vi vj
global alfa
global pi
global A
global mom_tool_axis
global tipo_angulo

if {$tipo_angulo == 0}  {
	#MOM_output_literal "angulo alfa para angulos"
	set vi $mom_tool_axis(0)
	set vj $mom_tool_axis(1)
}

if {[expr abs($vi)] > 0.0000000001}  {
	set alfa [expr atan($vj/$vi)]
}  else  {
	set alfa [expr $pi/2]
}

if {$vi > 0 && $vj > 0}  {
	set alfa $alfa
}  elseif {$vi < 0 && $vj > 0}  {
	set alfa [expr $pi - abs($alfa)]
}  elseif {$vi < 0 && $vj < 0}  {
	set alfa [expr $pi + abs($alfa)]
}  elseif {$vi > 0 && $vj < 0}  {
	set alfa [expr 2*$pi - abs($alfa)]
} 
	
#para 0 90 180 o 270
if {[expr abs($vi)] < 0.0000000001 && $vj > 0}  {
	set alfa [expr $pi/2]
}
if {[expr abs($vi)] < 0.0000000001 && $vj < 0}  {
	set alfa [expr 3*$pi/2]
}
if {$vi > 0.0 && [expr abs($vj)] < 0.0000000001}  {
	set alfa 0
}
if {$vi < 0.0 && [expr abs($vj)] < 0.0000000001}  {
	set alfa $pi
}

set A [expr sqrt($vi*$vi+$vj*$vj)]
#MOM_output_literal "tipo ang $tipo_angulo alfa $alfa A $A vi $vi vj $vj"
}


#=============================================================
proc PB_CMD_calculate_rotary_angles { } {
#=============================================================
#_______________________________________________________________________________
# This procedure calculates the position of the rotary axis in absolute Angles
# For a machine configuration like a DMG DMU xx eVolution
# Logic to control the C-axis that leaves it in rest position if the machine is 
# vertical position has to be arranged for outside this procedure
# Output Babs and Cabs
#_______________________________________________________________________________

global mom_mcs_goto
global mom_tool_axis
global pi
global Babs
global Cabs
global mom_operation_name
set Alpha 0
set Beta 0

IJK2AlphaBeta $mom_tool_axis(0) $mom_tool_axis(1) $mom_tool_axis(2) Alpha Beta

# If Beta is < 0 illegal axis position (no resolution for machine)
#MOM_output_literal "ALPHA $Alpha Beta $Beta"
if { $Beta < 0.0 } { 
  MOM_output_to_listing_device "FATAL ERROR!!!!!!!!\nOperation: $mom_operation_name"
  MOM_output_to_listing_device "Illegal tool-axis for this machine at position [format "X%.3f Y%.3f Z%.3f" $mom_mcs_goto(0) $mom_mcs_goto(1) $mom_mcs_goto(2)]"
  MOM_abort
}

#	Calculate intermediate values
	
	set e20 [expr cos($pi*$Beta/180)*cos($pi*$Alpha/180)]
	set e21 [expr cos($pi*$Beta/180)*sin($pi*$Alpha/180)]
	set e22 [expr sin($pi*$Beta/180)]
	set e14 [expr (acos(2*$e22-1))*180/$pi]
	set e23 [expr sqrt($e20*$e20+$e21*$e21+$e22*$e22)]


	if {$e20 > 0.0}  {
		if {$e21==0.0}  {
			set e15 [expr asin(($e22-$e23)/$e20)*180/$pi]
		}  else  {
			set e15 [expr asin(($e22-$e23)/sqrt($e20*$e20+$e21*$e21))-atan($e21/$e20)]
			set e15 [expr $e15*180/$pi]
		}
	}  elseif {$e20<0}  {
		if {$e21==0}  {
			set e15 [expr asin(($e22-$e23)/abs($e20))*180/$pi-180]
		}  else  {
			set e15 [expr asin(($e22-$e23)/sqrt($e20*$e20+$e21*$e21))-atan($e21/$e20)]
			set e15 [expr $e15*180/$pi-180]
		}
	}  elseif {$e21>0}  {
		set e15 [expr asin(($e22-$e23)/abs($e21))*180/$pi]
	}  elseif {$e21<0}  {
		set e15 [expr asin(($e22-$e23)/abs($e21))*180/$pi+90]
	}  else  {
		set e15 0
	}
		

	set Babs $e14
	set Cabs [expr $e15 *-1]

#MOM_output_literal "B $Babs C $Cabs"
}


#=============================================================
proc PB_CMD_calculate_rotary_angles_1 { } {
#=============================================================
#_______________________________________________________________________________
# This precedure calculates the position of the rotary axis in absolute Angles
# Logic to control the C-axis that leaves it in rest position if the machine is 
# vertical position has to be arranged for outside this procedure
# Output B and C
#_______________________________________________________________________________
global mom_tool_axis
global pi
global B
global C
global beta
global alfa
global o x y
global vi vj
global tipo_angulo
global B_inf B_sup B_ant
global num_iter

set tipo_angulo 0

set beta [expr $pi/2 - acos($mom_tool_axis(2))]
#MOM_output_literal "[expr $beta*180/$pi]"

set o [expr 2*sin($beta)*sin($beta)]
	
set B_inf 0
set B_sup [expr $pi]
set B_ant 100
set B	0
set num_iter 0

# iteraciones para buscar B
while {[expr abs($B_ant - $B)] > 0.0000001}  {
	set B_ant $B
	set num_iter [expr $num_iter+1]
	if {$num_iter > 1000000}  {
		break
	}
	set B [expr ($B_sup + $B_inf)/2]
	set x [expr cos($B)]
	set y [expr (1+$x*$x)*sin($pi/4+atan(1/$x))*sin($pi/4+atan(1/$x))]
	# MOM_output_literal "B $B B_inf $B_inf B_sup $B_sup B_ant $B_ant x $x y $y"
	if {$y > $o}  {
		set B_inf $B
	}  else  {
		set B_sup $B
	}
		
}

#esta parte hay que rehacerla para hacerla de forma iterativa
#buscar entre B0 y B180
#while {$y > $o}  #{
#	set x [expr cos($B)]
#	set y [expr (1+$x*$x)*sin($pi/4+atan(1/$x))*sin($pi/4+atan(1/$x))]
#	set B [expr $B+$pi/100000]
#}
	
set C [expr sqrt(1+cos($B)*cos($B))]
set C [expr $C*cos($pi/4+atan(1/cos($B)))]
set C [expr atan($C/sin($B))]
set C [expr abs($C)]
#set C [expr atan(sqrt(1+cos($B)*cos($B))*cos(pi/4+atan(1/cos($B))))/sin($B)])
#lo anterior es para alfa=0

PB_CMD_calculate_alpha
# Vertical tool-axis
if {$mom_tool_axis(2) > 0.99999999999}  {
	set alfa 0
	set C	 0
	set B    0
}
set C [expr $alfa + $C]
if {$C > 2*$pi}  {
	set C [expr $C - 2*$pi]
}
set B [expr $B*180/$pi]
set C [expr abs($C*180/$pi)]
MOM_output_literal "B $B C $C"
}


#=============================================================
proc PB_CMD_call_probe_cycle { } {
#=============================================================
# This procedure call the probe cycle under label 197
# The first time this procedure is called, thyere should be no output
# because there is no tool yet.

global gkw_probe_cycle_active
global gkw_label_call_number
global gkw_B_work_plane gkw_C_work_plane B C

if {[info exists gkw_probe_cycle_active]}  {
  set gkw_label_call_number 198
  MOM_do_template label_call_output
  # Label 198 calls a table reset, and resets the C-axis to 0
  # Therefore Cadd (additional C value for adding or subtracting increments of 360)
  # , B and C are reset to 0
  set Cadd 0
  set B 0
  set C 0
  VNC_rapid_home
  VNC_move_rapid_bc 0 0
  MOM_do_template rapid_traverse CREATE
  set gkw_label_call_number 190
  MOM_do_template label_call_output
  VNC_rapid_probe 
}
set gkw_probe_cycle_active 1
}


#=============================================================
proc PB_CMD_circle_direction { } {
#=============================================================
global mom_arc_direction circle_direction
global mom_pos_arc_plane

if {$mom_arc_direction == "CLW"} {set circle_direction "DR-"}
if {$mom_arc_direction == "CCLW"} {set circle_direction "DR+"}

switch $mom_pos_arc_plane {
  XY { MOM_force once X Y }
  YZ { MOM_force once Y Z }
  ZX { MOM_force once X Z }
}
}


#=============================================================
proc PB_CMD_clamp_fourth_axis { } {
#=============================================================
#
#  This procedure is used by auto clamping to output the code
#  needed to clamp the fourth axis.  
#
#  Do NOT add this block to events or markers.  It is a static 
#  block and it is not intended to be added to events.  Do NOT 
#  change the name of this custom command.
#
  MOM_output_literal "M10"
}


#=============================================================
proc PB_CMD_conditional_jump { } {
#=============================================================
# Unconditional Jump to first tool in Program

global mom_tool_number

MOM_output_literal "D09 P01 +0 P02 +0 P03 $mom_tool_number"
}


#=============================================================
proc PB_CMD_coolant_status_off { } {
#=============================================================
global mom_coolant_status

set mom_coolant_status "OFF"
}


#=============================================================
proc PB_CMD_cycle_init { } {
#=============================================================
global cycle_init_flag mom_cycle_delay

global mom_motion_event   mom_cycle_feed_to mom_cycle_retract_to     
global mom_tool_diameter   mom_cycle_step1 mom_cycle_feed_rate  
global cycle_peck_size cycle_type_number   ;# js
global js_prev_pos			   ;# diy previous Z height
global js_return_pos			   ;# returnZ incremental from top of hole

global mom_pos				;# xy and especially Z of this hole
global mom_prev_pos			;# ditto - previous hole
global mom_cycle_retract_mode
global gkw_cycle_clearance_direction 
global gkw_cycle_spindle_orient_angle 
global gkw_cycle_feed_rate_return
global gkw_cycle_min_step


# peck sizes 
set cycle_peck_size [expr ($mom_cycle_feed_to*(-1.0))] 	;# single peck size most cycles
if { $mom_motion_event == "drill_deep_move" || $mom_motion_event == "drill_break_chip_move"}  {
  if {($mom_cycle_step1 == 0)}  {
    set cycle_peck_size  $mom_tool_diameter ;# default peck  if not set
  }  else  {
    set cycle_peck_size  $mom_cycle_step1	;# real peck
  } 
}

# UGLY HACK start
# normally cycle_init_flag is only set if this is a new cycle
#  it is specifically unset in cycle_plane_change event, which
#  happens when a drilling operation goes uphill, 
#  ( drills a hole at a higher Z than the previous hole) 
#  it is _not_ set  when drilling downhill.
#  this next bit of code sets the variable for up or downhill
#  so that the new hole is defined - this is absolutely required
#  to ensure the hole Z height Q203 is set correctly.

if { $mom_pos(2) != $mom_prev_pos(2) }  {
	set cycle_init_flag  "TRUE"
}
#  UGLY HACK end

if {$cycle_init_flag == "TRUE"}  {
  if {![info exists mom_cycle_delay]}  {
    set mom_cycle_delay 0.0
  }

  if { $mom_cycle_retract_mode == "AUTO" }  {
    set js_return_pos [expr $js_prev_pos - $mom_pos(2)] ;# calc incr retract
  }  else  {
    set js_return_pos $mom_cycle_retract_to
  }

  set gkw_cycle_feed_rate_return 30000

# Heidenhain cycle types
  set cycle_type_number 200 	;# drill & peck
  switch $mom_motion_event  {
    drill_move -  drill_deep_move -  drill_dwell_move  {
      set cycle_type_number 200		; # drilling
      MOM_do_template cycle_block_def
      MOM_set_seq_off			; # no line numbers before cycle params
      MOM_do_template cycle_block_200 BUFFER
      MOM_output_literal "~"
      MOM_do_template cycle_block_201 BUFFER
      MOM_output_literal "~"
      MOM_do_template cycle_block_206 BUFFER
      MOM_output_literal "~"
      MOM_do_template cycle_block_202 BUFFER
      MOM_output_literal "~"
      MOM_do_template cycle_block_210 BUFFER
      MOM_output_literal "~"
      MOM_do_template cycle_block_203 BUFFER
      MOM_output_literal "~"
      MOM_do_template cycle_block_204 BUFFER
      MOM_output_literal "~"
      MOM_do_template cycle_block_211
    }
    bore_move -  bore_dwell_move  {
      set cycle_type_number 201		; # reaming
      MOM_do_template cycle_block_def
      MOM_set_seq_off			; # no line numbers before cycle params
      MOM_do_template cycle_block_200 BUFFER
      MOM_output_literal "~"
      MOM_do_template cycle_block_201 BUFFER
      MOM_output_literal "~"
      MOM_do_template cycle_block_206 BUFFER
      MOM_output_literal "~"
      MOM_do_template cycle_block_211 BUFFER
      MOM_output_literal "~"
      set gkw_cycle_feed_rate_return [expr $mom_cycle_feed_rate * 2]
      MOM_do_template cycle_block_208 BUFFER
      MOM_output_literal "~"
      MOM_do_template cycle_block_203 BUFFER
      MOM_output_literal "~"
      MOM_do_template cycle_block_204
    }
    bore_no_drag_move  {
      set cycle_type_number 202		; # boring
      MOM_do_template cycle_block_def
      MOM_set_seq_off			; # no line numbers before cycle params
      MOM_do_template cycle_block_200 BUFFER
      MOM_output_literal "~"
      MOM_do_template cycle_block_201 BUFFER
      MOM_output_literal "~"
      MOM_do_template cycle_block_206 BUFFER
      MOM_output_literal "~"
      MOM_do_template cycle_block_211 BUFFER
      MOM_output_literal "~"
      MOM_do_template cycle_block_208 BUFFER
      MOM_output_literal "~"
      MOM_do_template cycle_block_203 BUFFER
      MOM_output_literal "~"
      MOM_do_template cycle_block_204 BUFFER
      MOM_output_literal "~"
      set gkw_cycle_clearance_direction 1
      MOM_do_template cycle_block_214 BUFFER
      MOM_output_literal "~"
      set gkw_cycle_spindle_orient_angle 0
      MOM_do_template cycle_block_336
    }
    drill_break_chip_move  {
      set cycle_type_number 203		; # break_chip
      set gkw_cycle_min_step [expr $mom_tool_diameter/2]
      if { $mom_cycle_step1 < $gkw_cycle_min_step } { set gkw_cycle_min_step $mom_cycle_step1 }
      MOM_do_template cycle_block_def
      MOM_set_seq_off			; # no line numbers before cycle params
      MOM_do_template cycle_block_200 BUFFER
      MOM_output_literal "~"
      MOM_do_template cycle_block_201 BUFFER
      MOM_output_literal "~"
      MOM_do_template cycle_block_206 BUFFER
      MOM_output_literal "~"
      MOM_do_template cycle_block_202 BUFFER
      MOM_output_literal "~"
      MOM_do_template cycle_block_210 BUFFER
      MOM_output_literal "~"
      MOM_do_template cycle_block_203 BUFFER
      MOM_output_literal "~"
      MOM_do_template cycle_block_204 BUFFER
      MOM_output_literal "~"
      MOM_do_template cycle_block_212 BUFFER
      MOM_output_literal "~"
      MOM_do_template cycle_block_213 BUFFER
      MOM_output_literal "~"
      MOM_do_template cycle_block_205 BUFFER
      MOM_output_literal "~"
      MOM_do_template cycle_block_211 BUFFER
      MOM_output_literal "~"
      MOM_do_template cycle_block_208 BUFFER
      MOM_output_literal "~"
      MOM_do_template cycle_block_256
    }
    tap_move  {
      set cycle_type_number 207
      MOM_do_template cycle_block_def
      MOM_set_seq_off			; # no line numbers before cycle params
      MOM_do_template cycle_block_200 BUFFER
      MOM_output_literal "~"
      MOM_do_template cycle_block_201 BUFFER
      MOM_output_literal "~"
      MOM_do_template cycle_block_239 BUFFER
      MOM_output_literal "~"
      MOM_do_template cycle_block_203 BUFFER
      MOM_output_literal "~"
      MOM_do_template cycle_block_204
    }
    default  {
    set cycle_type_number -1
    }
  }
  MOM_set_seq_on			; # resume line numbers after cycle params
}
}


#=============================================================
proc PB_CMD_cycle_plane_change { } {
#=============================================================
# plane change happens when drilling operation goes uphill
# ie - when new hole is higher in Z than prev hole
# retract mode AUTO is return to clearance plane using
# Q204 ( which is like G98 ) so this next bit is only for
# case where cycles stay down 

global mom_cycle_retract_mode mom_cycle_rapid_to_pos mom_pos

#if { $mom_cycle_retract_mode != "AUTO" } { 

	MOM_force Once  G_motion Z	;# not sure why i need this
	MOM_do_template cycle_rapidtoZ	
#  }
VNC_cycle_rapid_z
}


#=============================================================
proc PB_CMD_default_labels_output { } {
#=============================================================
#
#  This custom command creates the part of the program that resets the cycle 19
#  Also outputs the part that sets the table in flat position
#  
global gkw_label_number
global gkw_alpha gkw_beta gkw_gamma
global mom_sys_control_out
global gkw_rel_msys
global mom_coolant_status

#-------------------------------------------------------------------------------

set gkw_label_number 190
MOM_do_template label_output
MOM_output_literal "$mom_sys_control_out $gkw_label_number # Standaard Breukcontrole"

set mom_coolant_status OFF
MOM_force once G_motion Z M M_coolant
MOM_do_template rapid_z_to_machine_coord
MOM_force once G_motion X Y M
MOM_do_template rapid_xy_to_machine_coord

MOM_output_literal "FN 18: SYSREAD Q1 = ID50 NR2"
MOM_output_literal "FN 9: IF +Q1 EQU +0 GOTO LBL 191"
MOM_output_literal "FN 18: SYSREAD Q2 = ID50 NR15"
MOM_output_literal "FN 9: IF +Q2 EQU +0 GOTO LBL 191"
MOM_output_literal "TOOL CALL Z S3000"
MOM_output_literal "TCH PROBE 585 SNIJKANTCONTROLE ~"
MOM_set_seq_off
MOM_output_literal "     Q353=+0    ;VERPLAATSINGSTRAJECT ~"
MOM_output_literal "     Q354=+100  ;VOEDING ~"
MOM_output_literal "     Q365=+0    ;AANTAL MEETPOSITIE"
MOM_set_seq_on
MOM_output_literal "FN 9: IF +Q199 EQU +2 GOTO LBL 150"

set gkw_label_number 0
MOM_do_template label_output

#-------------------------------------------------------------------------------

set gkw_label_number 191
MOM_do_template label_output

MOM_output_literal "TCH PROBE 586 WT-BREUKCONTROLE ~"
MOM_set_seq_off
MOM_output_literal "     Q356=+1 ~"
MOM_output_literal "     Q357=+0"
MOM_output_literal "FN 9: IF +Q199 EQU +2 GOTO LBL 150"
MOM_set_seq_on

set gkw_label_number 0
MOM_do_template label_output

#-------------------------------------------------------------------------------

set gkw_label_number 198
MOM_do_template label_output
MOM_output_literal "$mom_sys_control_out $gkw_label_number # Set Tables Horizontal"

MOM_force once G_motion Z M
MOM_do_template rapid_z_to_machine_coord
MOM_force once G_motion X Y M
MOM_do_template rapid_xy_to_machine_coord

set gkw_alpha 0
set gkw_beta 0
set gkw_gamma 0
MOM_do_template work_plane_def
MOM_do_template work_plane_angles
MOM_output_literal "M94"
MOM_do_template set_table_angles

MOM_suppress once A_alpha B_beta C_gamma
MOM_do_template work_plane_def
MOM_do_template work_plane_angles

set gkw_rel_msys(9) 0
set gkw_rel_msys(10) 0
set gkw_rel_msys(11) 0
MOM_do_template datum_shift_def
MOM_force once X Y Z
MOM_do_template datum_shift_x
MOM_do_template datum_shift_y
MOM_do_template datum_shift_z

set gkw_label_number 0
MOM_do_template label_output

#-------------------------------------------------------------------------------

set gkw_label_number 199
MOM_do_template label_output
MOM_output_literal "$mom_sys_control_out $gkw_label_number # Reset Cycle 19"

set gkw_alpha 0
set gkw_beta 0
set gkw_gamma 0
MOM_do_template work_plane_def
MOM_do_template work_plane_angles

MOM_suppress once A_alpha B_beta C_gamma
MOM_do_template work_plane_def
MOM_do_template work_plane_angles

set gkw_rel_msys(9) 0
set gkw_rel_msys(10) 0
set gkw_rel_msys(11) 0
MOM_do_template datum_shift_def
MOM_force once X Y Z
MOM_do_template datum_shift_x
MOM_do_template datum_shift_y
MOM_do_template datum_shift_z

MOM_force once G_motion Z M
MOM_do_template rapid_z_to_machine_coord
MOM_force once G_motion X Y M
MOM_do_template rapid_xy_to_machine_coord

set gkw_label_number 0
MOM_do_template label_output
}


#=============================================================
proc PB_CMD_end_of_alignment_character { } {
#=============================================================
 #  Return sequnece number back to orignal
 #  This command may be used with the command "PM_CMD_start_of_alignment_character"

  global mom_sys_leader saved_seq_num
  set mom_sys_leader(N) $saved_seq_num
}


#=============================================================
proc PB_CMD_error_report_to_screen { } {
#=============================================================
#
#  This custom command reports errors that where stored in an error file to the screen in
#  a TK window
#  If no errors occurred the old existing file is deleted
#

global gkw_error_file_ch
global gkw_error_file_name
global mom_output_file_directory
global mom_output_file_basename

if {[info exists gkw_error_file_ch] == 1 }  {
  close $gkw_error_file_ch
  set my_wish "[MOM_ask_env_var UGII_CAM_AUXILIARY_DIR]ugwish"
  set wish_script "[MOM_ask_env_var UGII_CAM_POST_DIR]error_list.tcl"
  set ier [catch {exec $my_wish $wish_script $gkw_error_file_name}]
  if {$ier == 1}  {
    set my_wish "wish"
    exec $my_wish $wish_script $gkw_error_file_name
  }
}  else  {
  set gkw_error_file_name "$mom_output_file_directory${mom_output_file_basename}_error.out"
  file delete $gkw_error_file_name
}
}


#=============================================================
proc PB_CMD_error_tool_number { } {
#=============================================================
# generate error message when toolnumber falls not in range

global mom_operation_name
global mom_tool_number
global gkw_error_message
global gkw_error_level

set range_low 1
set range_high 92

if { $mom_tool_number < $range_low || $mom_tool_number > $range_high }  {
  set gkw_error_level ERROR
  set gkw_error_message(0) "Error in Operation: $mom_operation_name"
  set gkw_error_message(1) "Toolnumber $mom_tool_number is not in specified range (${range_low}-${range_high})"

PB_CMD_log_error_to_file
}
}


#=============================================================
proc PB_CMD_error_unsupported_cycle { } {
#=============================================================
# generate error message when Cycle is not supported

global mom_operation_name
global gkw_error_message
global gkw_error_level

set gkw_error_level ERROR
set gkw_error_message(0) "Error in Operation: $mom_operation_name"
set gkw_error_message(1) "Cycle is not supported by Postprocessor"

PB_CMD_log_error_to_file
}


#=============================================================
proc PB_CMD_fifth_axis_rotate_move { } {
#=============================================================
#
#  This procedure is used by the ROTATE ude command to output a 
#  fifth axis rotary move.  You can use the NC Data Definitions
#  section of postbuilder to modify the fifth_axis_rotary_move
#  block template. 
#
#  Do NOT add this block to events or markers.  It is a static 
#  block and it is not intended to be added to events.  Do NOT 
#  change the name of this custom command.
#

  MOM_force once fifth_axis
  MOM_do_template fifth_axis_rotate_move
}


#=============================================================
proc PB_CMD_force_cycle_parameters { } {
#=============================================================
# this procedure forces all cycle definition parameters to be output
# at the start of the cycle
# decision is based on the fact that this is the first time the cycle is set

global gkw_prev_cycle_mode

if { $gkw_prev_cycle_mode == "OFF" }  {
  MOM_force once Q200_setup_clearance Q201_depth Q239_pitch Q206_feedrate_for_plunging Q202_plunge_depth Q210_dwell_time_top Q211_dwell_time_bottom Q208_retract_feedrate Q203_surface_level Q204_2nd_setup_clearance Q212_decrement Q213_no_of_breaks_before_retract Q205_minimum_plunge_depth Q211_dwell_time_bottom_1 Q208_retract_feedrate_1 Q214_disengage_direction Q256_retract_break_chip_dist Q366_angle_for_spindle_orient
  set gkw_prev_cycle_mode ON
}  else  {
  MOM_suppress once G_motion
}
}


#=============================================================
proc PB_CMD_force_motion_addresses { } {
#=============================================================
MOM_force always G_motion
}


#=============================================================
proc PB_CMD_fourth_axis_rotate_move { } {
#=============================================================
#
#  This procedure is used by the ROTATE ude command to output a 
#  fourth axis rotary move.  You can use the NC Data Definitions
#  section of postbuilder to modify the fourth_axis_rotary_move
#  block template. 
#
#  Do NOT add this block to events or markers.  It is a static 
#  block and it is not intended to be added to events.  Do NOT 
#  change the name of this custom command.
#

  MOM_force once fourth_axis
  MOM_do_template fourth_axis_rotate_move
}


#=============================================================
proc PB_CMD_init_helix { } {
#=============================================================
uplevel #0 {
#
# This procedure will be executed automatically at the start of program and
# anytime it is loaded as a slave post of a linked post.
#
# This procedure can be used to enable your post to output helix.
# You can choose from the following options to format the circle 
# block template to output the helix parameters.
#

set mom_sys_helix_pitch_type	"other"  

#
# The default setting for mom_sys_helix_pitch_type is "rise_radian".
# This is the most common.  Other choices are:
#
#    "rise_radian"              Measures the rise over one radian.
#    "rise_revolution"          Measures the rise over 360 degrees.
#    "none"                     Will suppress the output of pitch.
#    "other"                    Allows you to calculate the pitch
#                               using your own formula.
# 
# This custom command uses the block template circular_move to output
# the helix block.  If your post uses a block template with a different
# name, you must edit the line that outputs the helix block.


#=============================================================
proc MOM_helix_move { } {
#=============================================================
   global mom_pos_arc_plane
   global mom_arc_direction
   global mom_sys_cir_vector
   global mom_sys_helix_pitch_type
   global mom_helix_pitch
   global mom_helix_atangl
   global mom_prev_pos mom_pos_arc_center
   global rotation
   global PI
 
   switch $mom_sys_helix_pitch_type {
      none { }
      rise_radian { set pitch $mom_helix_pitch }
      rise_revolution { set pitch [expr $mom_helix_pitch * $PI * 2.0]}
      other {
              if {$mom_arc_direction == "CLW" } { 
                set rotation [expr abs($mom_helix_atangl) / $PI * -180 ] 
              } else {
                set rotation [expr abs($mom_helix_atangl) / $PI * 180 ]
              } 
      }
      default { set mom_sys_helix_pitch_type "none" }
   }
    
   MOM_force once X Y Z

   switch $mom_pos_arc_plane {
      XY { set cir_index 2 }
      YZ { set cir_index 0 }
      ZX { set cir_index 1 }
   }

   if {$mom_sys_helix_pitch_type != "none"} {
      MOM_force once I J K
      if {$mom_sys_cir_vector == "Vector - Arc Center to Start"} {
         set mom_prev_pos($cir_index) 0.0
         set mom_pos_arc_center($cir_index) $pitch
      } elseif {$mom_sys_cir_vector == "Vector - Arc Start to Center"} {
         set mom_prev_pos($cir_index) $pitch
         set mom_pos_arc_center($cir_index) 0.0
      } elseif {$mom_sys_cir_vector == "Unsigned Vector - Arc Center to Start"} {
         set mom_prev_pos($cir_index) 0.0
         set mom_pos_arc_center($cir_index) $pitch
      } elseif {$mom_sys_cir_vector == "Absolute Arc Center"} {
         set mom_pos_arc_center($cir_index) $pitch
      }
   }


#
# You may need to edit this line if you output more than one block
# or if you have changed the name of your circular_move block template
#
   switch $mom_pos_arc_plane {
      XY { MOM_suppress once K }
      YZ { MOM_suppress once I }
      ZX { MOM_suppress once J }
   }

   MOM_do_template circular_move
   PB_CMD_circle_direction
   MOM_do_template helix_move


} ;# MOM_helix_move


} ;# uplevel
}


#=============================================================
proc PB_CMD_init_multi_axis { } {
#=============================================================
# Init M128 when operation is a multi_axis operation
# Check if programming is in Absolute MSYS (no cycle 19)

global gkw_tpcm_mode
global mom_operation_type
global mom_msys_matrix mom_msys_origin

if {$gkw_tpcm_mode == 128} return

switch [string range $mom_operation_type 0 4] {
  Seque - Varia { 
    set matrix ""
    for {set i 0} {$i <= 8} {incr i}  {
      set matrix $matrix[expr round($mom_msys_matrix($i)*1000)]
    }
    for {set i 0} {$i <= 2} {incr i}  {
      set matrix $matrix[expr round($mom_msys_origin($i)*1000)]
    }
    if { $matrix == "100000010000001000000" } {
      set gkw_tpcm_mode 128
      MOM_suppress once X Y Z
      MOM_do_template rapid_traverse
      VNC_rapid_bc
      MOM_do_template m_tpcm
    } else {
      # generate error when msys is not at origin

      global mom_operation_name
      global gkw_error_message
      global gkw_error_level

      set gkw_error_level ERROR
      set gkw_error_message(0) "Error in Operation: $mom_operation_name"
      set gkw_error_message(1) "Multi-Axis operation is not related to the absolute MSYS"
      PB_CMD_log_error_to_file
    }
  }
}
}


#=============================================================
proc PB_CMD_init_rotary { } {
#=============================================================
uplevel #0 {

#
# Fourth Axis Auto Clamping is activated by programming the
# UDE CLAMP/AUTO,ON in your tool path.  Fourth Axis Auto
# Clamping may be turned off by programming the UDE CLAMP/AUTO,OFF.
#
# An M10 will be output to clamp the XYZ axis for fourth axis 
# motion. An M11 will be output to un-clamp the fourth axis 
# when fourth axis motion occurs in the block.  You may edit 
# the custom commands PB_CMD_clamp_fourth_axis or 
# PB_CMD_unclamp_fourth_axis to output codes other than M10 or M11.
# 
#
# Retract and Re-Engage Parameters
#
# This option is activated by setting the Axis Limit Violation 
# Handling option on the Machine Tool dialog to Retract / Re-Engage.  
#
# The sequence of actions that take place when a rotary limit violation
# occurs is a retract to the clearance plane at the rapid feedrate, 
# reposition the rotary axes so they do not violate, move back to 
# the engage point at the retract feedrate and engage into the part again.
#
# You can set additional parameters that will control the retract 
# and re-engage motion.
#
# The parameter "mom_kin_retract_plane" defines the distance
# from the center of rotation that the tool will retract when
# an axis violation occurs.  For a four axis head machine tool the
# retraction will be a cylinder.  For a five axis head machine tool
# the retraction will be to a sphere. For rotary tables the
# retraction will be to a plane along the spindle axis.
#

set mom_kin_retract_plane                      10.0


#
# The parameter "mom_kin_reengage_distance" defines the engage
# point above the part.
#

set mom_kin_reengage_distance                  .1


#
# The following parameters are used by UG Post.  Do NOT change 
# them unless you know what you are doing.
#

set mom_kin_spindle_axis(0)                    0.0
set mom_kin_spindle_axis(1)                    0.0
set mom_kin_spindle_axis(2)                    1.0

if [info exists mom_sys_spindle_axis] { unset mom_sys_spindle_axis }

set mom_sys_spindle_axis(0)                    0.0
set mom_sys_spindle_axis(1)                    0.0
set mom_sys_spindle_axis(2)                    1.0

set mom_sys_lock_status                        "OFF"

} ;# uplevel
}


#=============================================================
proc PB_CMD_init_vars { } {
#=============================================================
# Sets initial variables used for several codes which or not automaticly
# set by the postbuilder


global gkw_tpcm_mode
set gkw_tpcm_mode 129
MOM_do_template m_tpcm CREATE

uplevel #0  {

# set custom variable gkw_prev_cycle_mode to OFF, so the custom command for
# cycles can see what the status of the cycle is

set gkw_prev_cycle_mode OFF

# set several default values

set gkw_machine_coord_m_code 92
set gkw_set_work_plane_g_code 80
set gkw_program_datum_shift_g_code 54

# Additional Coolant variables

set mom_sys_coolant_code(THRU)                "7"  
set mom_sys_coolant_code(MIST_THRU)           "26"  

set mom_coolant_status "OFF"

# Set Simulation Home Position

set gkw_sim_home_pos(0) -500
set gkw_sim_home_pos(1) -200
set gkw_sim_home_pos(2) 0

# Hold Previous values to support Liniarization

array set gkw_prev_tool_axis [array get mom_tool_axis]
array set gkw_prev_mcs_goto [array get mom_mcs_goto]

set pi				    [expr 4*atan(1)]
set B				      0
set C				      0
set Babs          0
set Cabs          0
set Cadd          0
set Bold			    0
set Cold			    0

# Tolerance for liniarization in degrees
set tollin			    5

# Init for Simulation
set X_sim_old_pos 0
set Y_sim_old_pos 0
set Z_sim_old_pos 0
set B_sim_old_pos 0
set C_sim_old_pos 0
set gkw_B_work_plane 0
set gkw_C_work_plane 0

##set alfa			    0
#set beta			    0
#set tiempo_espera		    0
#set xi				    0
#set yi				    0
#set zi				    0
#set xc				    0
#set yc				    0
#set zc				    0
#set xfc				    0
#set yfc				    0
#set zfc				    0
#set xf				    0
#set yf				    0
#set zf				    0
#set xfl				    0
#set yfl				    0
#set zfl				    0
#set vi				    0
#set vj				    0
#set A				    0
#set tipo_angulo			    0
#set Cabs			    0
#set Cant			    0
#set Cinc			    0
#set Bant			    0
#set Binc			    0
#set num_mov			    0 
#set num_pasos_lin		    0
#set xfsave			    0
#set yfsave			    0
#set zfsave			    0
#set Bsave			    0
#set Csave			    0
#set xlinc			    0
#set ylinc			    0
#set zlinc		            0
#set ilinc			    0
#set jlinc			    0
#set klinc			    0
#set contador			    0
#set Cabs_antiguo		    0
#set Cfinal			    0
#para interpolacion circular
}
}


#=============================================================
proc PB_CMD_kin_before_motion { } {
#=============================================================
#
#  This custom command is used by UG Post to support Set/Lock, 
#  rotary axis limit violation retracts and auto clamping.  
#  Do not change this procedure.  If you want to improve 
#  performance, you may comment out any of these procedures.
#  

   global mom_kin_machine_type

   if [info exists mom_kin_machine_type] {
      if { [string match "*3_axis_mill*" $mom_kin_machine_type] ||  [string match "*lathe*" $mom_kin_machine_type] } {
return
      }
   }


   LOCK_AXIS_MOTION

   ROTARY_AXIS_RETRACT

   AUTO_CLAMP
}


#=============================================================
proc PB_CMD_kin_feedrate_set { } {
#=============================================================
# This procedure supercedes the functionalites provided by the
# FEEDRATE_SET in ugpost_base.tcl.  Post Builder automatically
# generates proper call sequences to this procedure in the
# Event handlers.
#
# This procedure must be used in conjunction with ugpost_base.tcl.
#
  global   feed com_feed_rate
  global   mom_feed_rate_output_mode super_feed_mode feed_mode
  global   mom_cycle_feed_rate_mode mom_cycle_feed_rate
  global   mom_cycle_feed_rate_per_rev
  global   mom_motion_type
  global   mom_warning_info
  global   Feed_IPM Feed_IPR Feed_MMPM Feed_MMPR Feed_INV
  global   mom_sys_feed_param
  global   mom_sys_cycle_feed_mode


  set super_feed_mode $mom_feed_rate_output_mode

  set f_pm [ASK_FEEDRATE_FPM] ; set f_pr [ASK_FEEDRATE_FPR]

  switch $mom_motion_type {

    CYCLE {
      if [info exists mom_sys_cycle_feed_mode] {
         if { $mom_sys_cycle_feed_mode != "Auto" } {
            set mom_cycle_feed_rate_mode $mom_sys_cycle_feed_mode
         }
      }
      if {[hiset mom_cycle_feed_rate_mode]} { set super_feed_mode $mom_cycle_feed_rate_mode }
      if {[hiset mom_cycle_feed_rate]} { set f_pm $mom_cycle_feed_rate }
      if {[hiset mom_cycle_feed_rate_per_rev]} { set f_pr $mom_cycle_feed_rate_per_rev }
    }

    FROM -
    RETRACT -
    RETURN -
    LIFT -
    TRAVERSAL -
    GOHOME -
    GOHOME_DEFAULT -
    RAPID {
      SUPER_FEED_MODE_SET RAPID
    }

    default {
      if {[EQ_is_zero $f_pm] && [EQ_is_zero $f_pr]} {
        SUPER_FEED_MODE_SET RAPID
      } else {
        SUPER_FEED_MODE_SET CONTOUR
      }
    }
  }


  set feed_mode $super_feed_mode


 # Adjust feedrate format per Post output unit again.
  global mom_kin_output_unit
  if { $mom_kin_output_unit == "IN" } {
     switch $feed_mode {
       MMPM {
         set feed_mode "IPM"
         CATCH_WARNING "Feedrate mode MMPM changed to IPM"
       }
       MMPR {
         set feed_mode "IPR"
         CATCH_WARNING "Feedrate mode MMPR changed to IPR"
       }
     }
  } else {
     switch $feed_mode {
       IPM {
         set feed_mode "MMPM"
         CATCH_WARNING "Feedrate mode IPM changed to MMPM"
       }
       IPR {
         set feed_mode "MMPR"
         CATCH_WARNING "Feedrate mode IPR changed to MMPR"
       }
     }
  }


  switch $feed_mode {
    IPM     -
    MMPM    { set feed $f_pm }
    IPR     -
    MMPR    { set feed $f_pr }
    DPM     { set feed [PB_CMD_FEEDRATE_DPM] }
    FRN     -
    INVERSE { set feed [PB_CMD_FEEDRATE_NUMBER] }
    default { set mom_warning_info "INVALID FEED RATE MODE" ; MOM_catch_warning ; return }
  }


 # Post Builder provided format for the current mode:
  if [info exists mom_sys_feed_param(${feed_mode},format)] {
    MOM_set_address_format F $mom_sys_feed_param(${feed_mode},format)
  } else {
    switch $feed_mode {
      IPM     -
      MMPM    -
      IPR     -
      MMPR    -
      DPM     -
      FRN     { MOM_set_address_format F Feed_${feed_mode} }
      INVERSE { MOM_set_address_format F Feed_INV }
    }
  }

 # Commentary output
  set com_feed_rate $f_pm


 # Execute user's commnad, if any.
  if [llength [info commands "PB_CMD_FEEDRATE_SET"]] {
     PB_CMD_FEEDRATE_SET
  }
}


#=============================================================
proc PB_CMD_kin_init_mill_turn { } {
#=============================================================
}


#=============================================================
proc PB_CMD_kin_init_mill_xzc { } {
#=============================================================
}


#=============================================================
proc PB_CMD_kin_init_rotary { } {
#=============================================================

   global mom_kin_machine_type

   if [info exists mom_kin_machine_type] {
      if { [string match "*3_axis_mill*" $mom_kin_machine_type] ||  [string match "*lathe*" $mom_kin_machine_type] } {
return
      }
   }


   PB_CMD_init_rotary


uplevel #0 {


#=============================================================
proc MOM_clamp { } {
#=============================================================
  global mom_clamp_axis mom_clamp_status mom_sys_auto_clamp

   if {$mom_clamp_axis == "AUTO"} {
      if {$mom_clamp_status == "ON"} {
         set mom_sys_auto_clamp "ON"
      } elseif {$mom_clamp_status == "OFF"} {
         set mom_sys_auto_clamp "OFF"
      }
   }
}

#=============================================================
proc MOM_rotate { } {
#=============================================================
  global mom_rotate_axis_type mom_rotation_mode mom_rotation_direction
  global mom_rotation_angle mom_rotation_reference_mode
  global mom_kin_machine_type mom_kin_4th_axis_direction mom_kin_5th_axis_direction
  global mom_kin_4th_axis_leader mom_kin_5th_axis_leader
  global mom_kin_4th_axis_leader mom_kin_5th_axis_leader mom_pos
  global mom_out_angle_pos mom_prev_out_angle_pos
  global mom_prev_pos mom_sys_leader

   if {![info exists mom_rotation_angle]} {return}

  #
  #  Determine which axis the user wanted, fourth or fifth.
  #
   switch $mom_rotate_axis_type {
      AAXIS {
         set axis [AXIS_SET $mom_rotate_axis_type]
      }
      BAXIS {
         set axis [AXIS_SET $mom_rotate_axis_type]
      }
      CAXIS {
         set axis [AXIS_SET $mom_rotate_axis_type]
      }
      TABLE {
         set axis 3
      }
      HEAD {
         if { $mom_kin_machine_type == "5_axis_head_table ||  $mom_kin_machine_type == "5_AXIS_HEAD_TABLE" } {
            set axis 4
         } else {
            set axis 3
         }
      }
      default {
         set axis 3
      }
   }

   switch $mom_rotation_mode {
      NONE {
         set angle $mom_rotation_angle
         set mode 0
      }
      ATANGLE {
         set angle $mom_rotation_angle
         set mode 0
      }
      ABSOLUTE {
         set angle $mom_rotation_angle
         set mode 1
      }
      INCREMENTAL {
         set angle [expr $mom_pos($axis) + $mom_rotation_angle]
         set mode 0
      }
   }
   switch $mom_rotation_direction {
      NONE {
         set dir 0
      }
      CLW {
         set dir 1
      }
      CCLW {
         set dir -1
      }
   }

   set ang [LIMIT_ANGLE $angle]
   set mom_pos($axis) $ang


   if {$axis == "3" && ![info exists mom_prev_out_angle_pos(0)]} {
      set mom_prev_out_angle_pos(0) [MOM_ask_address_value fourth_axis]
      if {$mom_prev_out_angle_pos(0) == ""} {set mom_prev_out_angle_pos(0) 0.0} 
   } 

 
   if {$axis == "4" && ![info exists mom_prev_out_angle_pos(1)]} {  
      set mom_prev_out_angle_pos(1) [MOM_ask_address_value fifth_axis]
      if {$mom_prev_out_angle_pos(1) == ""} {set mom_prev_out_angle_pos(1) 0.0}
   }

   set p [expr $axis + 1]
   set a [expr $axis - 3]
   if {$axis == "3" && $mom_kin_4th_axis_direction == "MAGNITUDE_DETERMINES_DIRECTION"} {
      set dirtype 0
   } elseif { $axis == "4" &&  $mom_kin_5th_axis_direction == "MAGNITUDE_DETERMINES_DIRECTION" } {
      set dirtype 0
   } else {
      set dirtype 1
   }

   if {$mode == 1} {
      set mom_out_angle_pos($a) $angle
   } elseif {$dirtype == 0} {

      if {$axis == 3} {
         set mom_out_angle_pos($a) [ROTSET $ang  $mom_prev_out_angle_pos(0) $mom_kin_4th_axis_direction  $mom_kin_4th_axis_leader mom_sys_leader(fourth_axis)]
      } else {
         set mom_out_angle_pos($a) [ROTSET $ang  $mom_prev_out_angle_pos(1) $mom_kin_5th_axis_direction  $mom_kin_5th_axis_leader mom_sys_leader(fifth_axis)]
      }

      if {$axis == 3} {set prot $mom_prev_out_angle_pos(0)}
      if {$axis == 4} {set prot $mom_prev_out_angle_pos(1)}
      if {$dir == 1 && $mom_out_angle_pos($a) < $prot} {
         set mom_out_angle_pos($a) [expr $mom_out_angle_pos($a) + 360.0] 
      } elseif {$dir == -1 && $mom_out_angle_pos($a) > $prot} {
         set mom_out_angle_pos($a) [expr $mom_out_angle_pos($a) - 360.0]
      }
   } elseif {$dirtype == "1"} {

      if {$dir == -1} {
         if {$axis == 3} {
            set mom_sys_leader(fourth_axis) $mom_kin_4th_axis_leader-
         } else {
            set mom_sys_leader(fifth_axis) $mom_kin_5th_axis_leader-
         }
      } elseif {$dir == 0} {
         if {$axis == 3} {
            set mom_out_angle_pos($a) [ROTSET $ang  $mom_prev_out_angle_pos(0) $mom_kin_4th_axis_direction  $mom_kin_4th_axis_leader mom_sys_leader(fourth_axis)]
         } else {
            set mom_out_angle_pos($a) [ROTSET $ang  $mom_prev_out_angle_pos(1) $mom_kin_5th_axis_direction  $mom_kin_5th_axis_leader mom_sys_leader(fifth_axis)]
         }
      } elseif {$dir == 1} {
         set mom_out_angle_pos($a) $ang
      }
   }

   if {$axis == 3} {
      PB_CMD_fourth_axis_rotate_move
   } else {
      PB_CMD_fifth_axis_rotate_move
   }

   MOM_reload_variable -a mom_out_angle_pos
}

#=============================================================
proc MOM_lock_axis { } {
#=============================================================
  global mom_sys_lock_value mom_sys_lock_plane
  global mom_sys_lock_axis mom_sys_lock_status

   set status [SET_LOCK axis plane value]
   if {$status == "error"} {
      MOM_catch_warning
      set mom_sys_lock_status OFF
   } else {
      set mom_sys_lock_status $status
      if {$status != "OFF"} {
         set mom_sys_lock_axis $axis
         set mom_sys_lock_plane $plane
         set mom_sys_lock_value $value
      }
   }
}

#=============================================================
proc PB_catch_warning { } {
#=============================================================
  global mom_sys_rotary_error mom_warning_info

   if {$mom_warning_info == "ROTARY CROSSING LIMIT."} {
      set mom_sys_rotary_error $mom_warning_info
   }
   if {$mom_warning_info == "secondary rotary position being used"} {
      set mom_sys_rotary_error $mom_warning_info
   }
}



} ;# uplevel
}


#=============================================================
proc PB_CMD_kin_mill_turn_initialize { } {
#=============================================================
}


#=============================================================
proc PB_CMD_kin_mill_xzc_init { } {
#=============================================================
}


#=============================================================
proc PB_CMD_kin_start_of_path { } {
#=============================================================
#
#  This procedure is executed at the start of every operation.
#  It will check to see if a new head (post) was loaded and 
#  will then initialize any functionality specific to that post.
#
#  It will also restore the initial Start of Program or End
#  of program event procedures.
#
#  DO NOT CHANGE THIS FILE UNLESS YOU KNOW WHAT YOU ARE DOING.
#  DO NOT CALL THIS PROCEDURE FROM ANY OTHER CUSTOM COMMAND.
#
  global mom_sys_head_change_init_program

   if [info exists mom_sys_head_change_init_program] {

      PB_CMD_kin_start_of_program
      unset mom_sys_head_change_init_program

      if [llength [info commands "MOM_start_of_program_save"]] {
         rename MOM_start_of_program ""
         rename MOM_end_of_program ""
         rename MOM_start_of_program_save MOM_start_of_program 
         rename MOM_end_of_program_save MOM_end_of_program 
      }
   }
}


#=============================================================
proc PB_CMD_kin_start_of_program { } {
#=============================================================
#
#  This procedure will execute the following custom commands for
#  initialization.  They will be executed once at the start of 
#  program and again each time they are loaded as a linked post.  
#  After execution they will be deleted so that they are not 
#  present when a different post is loaded.  You may add a call 
#  to a procedure that you want executed when a linked post is 
#  loaded.  
#
#  Note that when a linked post is called in, the Start of Program
#  event marker is not executed again, only this procedure.
#
#  DO NOT REMOVE ANY LINES FROM THIS PROCEDURE UNLESS YOU KNOW
#  WHAT YOU ARE DOING.  DO NOT CALL THIS PROCEDURE FROM ANY
#  OTHER CUSTOM COMMAND.
#

   global mom_kin_machine_type

   set command_list [list]

   if [info exists mom_kin_machine_type] {
      if { ![string match "*3_axis_mill*" $mom_kin_machine_type] &&  ![string match "*lathe*" $mom_kin_machine_type] } {

         lappend command_list  PB_CMD_kin_init_rotary
      }
   }

   lappend command_list  PB_CMD_init_auto_retract
   lappend command_list  PB_CMD_multiple_post_initialize
   lappend command_list  PB_CMD_init_multiple_post
   lappend command_list  PB_CMD_initialize_parallel_zw_mode
   lappend command_list  PB_CMD_init_parallel_zw_mode
   lappend command_list  PB_CMD_initialize_tool_list
   lappend command_list  PB_CMD_init_tool_list
   lappend command_list  PB_CMD_init_tape_break
   lappend command_list  PB_CMD_initialize_spindle_axis
   lappend command_list  PB_CMD_init_spindle_axis
   lappend command_list  PB_CMD_initialize_helix
   lappend command_list  PB_CMD_init_helix
   lappend command_list  PB_CMD_pq_cutcom_initialize
   lappend command_list  PB_CMD_init_pq_cutcom

   if [info exists mom_kin_machine_type] {
      if { [string match "*3_axis_mill_turn*" $mom_kin_machine_type] } {
          lappend command_list  PB_CMD_kin_init_mill_xzc
          lappend command_list  PB_CMD_kin_mill_xzc_init
          lappend command_list  PB_CMD_kin_init_mill_turn
          lappend command_list  PB_CMD_kin_mill_turn_initialize
      }
   }


   foreach cmd $command_list {

      if [llength [info commands "$cmd"]] {
         $cmd
         rename $cmd ""
         proc $cmd { args } {} 
      }
   }
}


#=============================================================
proc PB_CMD_linear_move { } {
#=============================================================
#
#  This procedure is used my many automatic postbuilder functions 
#  to output a linear move.  Do NOT add this block to events or
#  markers.  It is a static block and it is not intended to be added
#  to events.  Do NOT change the name of this procedure.  
#
#  If you need a custom command to be output with a linear move block, 
#  you must place a call to the custom command either before or after 
#  the MOM_do_template command.
#
#  This proc is used for:
#     simulated cycles feed moves
#     mill/turn mill linearization
#     four and five axis retract and re-engage
#     

  MOM_do_template linear_move
}


#=============================================================
proc PB_CMD_linearization { } {
#=============================================================
#_______________________________________________________________________________
# calcula puntos intermedios cuando la rotacin es grande (segn tollin)
#
#_______________________________________________________________________________
global xfl yfl zfl Bl Cl
global xi yi zi
global num_pasos_lin
global mom_prev_mcs_goto mom_prev_tool_axis gkw_prev_tool_axis gkw_prev_mcs_goto
global mom_mcs_goto mom_tool_axis 
global C Cinc Cabs inc1 Cant B Bant Cabs_antiguo Bsave Csave
global xlinc ylinc zlinc ilinc jlinc klinc
global contador tollin pi
global inc2 Bbase
global componente_k


set contador 0

#busco incrementos en x y z i j k

set xlinc [expr ($mom_mcs_goto(0)-$gkw_prev_mcs_goto(0))/$num_pasos_lin]
set ylinc [expr ($mom_mcs_goto(1)-$gkw_prev_mcs_goto(1))/$num_pasos_lin]
set zlinc [expr ($mom_mcs_goto(2)-$gkw_prev_mcs_goto(2))/$num_pasos_lin]
	
set ilinc [expr ($mom_tool_axis(0)-$gkw_prev_tool_axis(0))/$num_pasos_lin]
set jlinc [expr ($mom_tool_axis(1)-$gkw_prev_tool_axis(1))/$num_pasos_lin]
set klinc [expr ($mom_tool_axis(2)-$gkw_prev_tool_axis(2))/$num_pasos_lin]
MOM_output_literal "Prev. Tool axis:$gkw_prev_tool_axis(0) $gkw_prev_tool_axis(1) $gkw_prev_tool_axis(2)"
MOM_output_literal "Tool axis:      $mom_tool_axis(0) $mom_tool_axis(1) $mom_tool_axis(2)"

set Cabs $Cabs_antiguo
set inc2 [expr ($Bsave-$Bant)/$num_pasos_lin]
set Bbase $Bant
set componente_k $mom_tool_axis(2)
while {$contador < $num_pasos_lin}  {
	set contador [expr $contador + 1]
       	set xi [expr $gkw_prev_mcs_goto(0) + $xlinc*$contador]
	set yi [expr $gkw_prev_mcs_goto(1) + $ylinc*$contador]
	set zi [expr $gkw_prev_mcs_goto(2) + $zlinc*$contador]
	#miro si se sale o llega de la vertical o no
		
	if {$gkw_prev_tool_axis(2) < 0.9999999999 && $componente_k < 0.99999999}  {
		# no viene de la vertical ni va
		set mom_tool_axis(0) [expr $gkw_prev_tool_axis(0) + $ilinc*$contador]
		set mom_tool_axis(1) [expr $gkw_prev_tool_axis(1) + $jlinc*$contador]
		set mom_tool_axis(2) [expr $gkw_prev_tool_axis(2) + $klinc*$contador]
	}  else  {
		# viene de la vertical o va a la vertical
		set inc3 [expr (($Csave-$Cabs_antiguo)/$num_pasos_lin)*$contador]
		set mom_tool_axis(0) [expr 0.000002*cos(($Cabs_antiguo+$inc3)*$pi/180)]
		set mom_tool_axis(1) [expr 0.000002*sin(($Cabs_antiguo+$inc3)*$pi/180)]
		set mom_tool_axis(2) [expr $gkw_prev_tool_axis(2) + $klinc*$contador]
		#MOM_output_literal "angulo [expr $contador*$tollin]"
		#MOM_output_literal "mom_tool_axis(0) $mom_tool_axis(0)"
		#MOM_output_literal "mom_tool_axis(1) $mom_tool_axis(1)"
		#MOM_output_literal "mom_tool_axis(2) $mom_tool_axis(2)"
	} 
	#MOM_output_literal "mom_tool_axis(0) $mom_tool_axis(0)"
	#MOM_output_literal "mom_tool_axis(1) $mom_tool_axis(1)"
	#MOM_output_literal "mom_tool_axis(2) $mom_tool_axis(2)"
       	PB_CMD_calculate_rotary_angles
	#el angulo B lo calculo otra vez entre 0 y B final si se pasa de hta vertical a otro angulo
	if {$gkw_prev_tool_axis(2) > 0.9999999999}  { 
		set B [expr $Bbase + $inc2*$contador]
	}
       	#PB_CMD_transform_coord
	MOM_output_literal "C $C Cant $Cant Cabs $Cabs"
	set inc1 [expr $C - $Cant]
	
	#busco el camino ms corto
	if {$inc1 < -180}  {
		set Cinc  [expr 360 + $inc1]
	} 
	
	if {$inc1 > 180}  {
		set Cinc  [expr $inc1 - 360]
	} 
        
	if {$inc1 > -180 && $inc1 < 180}  {
		set Cinc $inc1
	}
	        
	
	set Cabs [expr $Cabs + $Cinc]
	#MOM_output_literal "Cabs $Cabs inc1 $inc1"
	#MOM_do_template linear
	set Cant $C
	set Bant $B
	VNC_linear
		
}
}


#=============================================================
proc PB_CMD_log_error_to_file { } {
#=============================================================
#
#  This custom command reports errors to a file 
#

global gkw_error_file_ch
global gkw_error_file_name
global gkw_error_message
global gkw_error_level
global mom_output_file_directory
global mom_output_file_basename

if {[info exists gkw_error_file_ch] == 0 }  {
  set gkw_error_file_name "$mom_output_file_directory${mom_output_file_basename}_error.out"
  set gkw_error_file_ch [open $gkw_error_file_name w]
}

puts $gkw_error_file_ch [format "%-8s%-80s" $gkw_error_level $gkw_error_message(0)]
for {set i 1} {$i < [array size gkw_error_message]} {incr i}  {
puts $gkw_error_file_ch [format "        %-80s" $gkw_error_message($i)]
}
unset gkw_error_message
}


#=============================================================
proc PB_CMD_nurbs_initialize { } {
#=============================================================
#
#  You will need to activate nurbs motion in Unigraphics CAM under 
#  machine control to generate nurbs events.
#
#  This procedure is used to establish nurbs parameters.  It must be 
#  placed in the Start of Program marker to output nurbs.
#
uplevel #0 {

 set mom_kin_nurbs_output_type                  HEIDENHAIN_POLY
 
 MOM_reload_kinematics

proc  MOM_nurbs_move {} {
#_______________________________________________________________________________
# This procedure is executed for each Nurbs machining move.
#_______________________________________________________________________________
  global mom_nurbs_point_count
  global mom_nurbs_points 
  global mom_nurbs_coefficients 
  global mom_nurbs_points_x
  global mom_nurbs_points_y
  global mom_nurbs_points_z
  global mom_nurbs_co_efficient_0
  global mom_nurbs_co_efficient_1
  global mom_nurbs_co_efficient_2
  global mom_nurbs_co_efficient_3
  global mom_nurbs_co_efficient_4
  global mom_nurbs_co_efficient_5
  global mom_nurbs_co_efficient_6
  global mom_nurbs_co_efficient_7
  global mom_nurbs_co_efficient_8


  MOM_force once F
  
  MOM_do_template spline_start

  for {set ii 0} {$ii < $mom_nurbs_point_count} {incr ii} {
       set poly_output_mode "SPL"
       set mom_nurbs_points_x       $mom_nurbs_points($ii,0)
       set mom_nurbs_points_y       $mom_nurbs_points($ii,1)
       set mom_nurbs_points_z       $mom_nurbs_points($ii,2)
       set mom_nurbs_co_efficient_0 $mom_nurbs_coefficients($ii,0)
       set mom_nurbs_co_efficient_1 $mom_nurbs_coefficients($ii,1)
       set mom_nurbs_co_efficient_2 $mom_nurbs_coefficients($ii,2)
       set mom_nurbs_co_efficient_3 $mom_nurbs_coefficients($ii,3)
       set mom_nurbs_co_efficient_4 $mom_nurbs_coefficients($ii,4)
       set mom_nurbs_co_efficient_5 $mom_nurbs_coefficients($ii,5)
       set mom_nurbs_co_efficient_6 $mom_nurbs_coefficients($ii,6)
       set mom_nurbs_co_efficient_7 $mom_nurbs_coefficients($ii,7)
       set mom_nurbs_co_efficient_8 $mom_nurbs_coefficients($ii,8)

       MOM_do_template nurbs_spline
       MOM_do_template nurbs_coeff_x
       MOM_do_template nurbs_coeff_y
       MOM_do_template nurbs_coeff_z
  }

}

}
}


#=============================================================
proc PB_CMD_post_name { } {
#=============================================================
# echo back the post file location
# options for full path name, file name only , uppercase

  global mom_event_handler_file_name	
  MOM_output_literal ";   POSTPROCESSOR NAME  "
  MOM_output_literal ";  [ string toupper $mom_event_handler_file_name ] ) "
  MOM_output_literal ";   "
}


#=============================================================
proc PB_CMD_print_MSYS { } {
#=============================================================
# this procedure prints the matrix of the MSYS in relation to the init MSYS
# that is stored in gkw_init_msys_matrix and gkw_init_msys_origin

global mom_msys_matrix 
global mom_msys_origin
global gkw_init_msys_matrix 
global gkw_init_msys_origin

MTX3_multiply gkw_init_msys_matrix mom_msys_matrix mx

global mom_oper_geom
MOM_output_literal "Parent $mom_oper_geom"
MOM_output_literal "relative MSYS matrix"
for {set i 0} {$i < 9} {incr i}  {
  MOM_output_literal [format "%1.6f" $mx($i)]
}
}


#=============================================================
proc PB_CMD_program_name_end { } {
#=============================================================
# Outputs the last line with program number limited to 18 characters

global mom_group_name

MOM_output_literal "N999999 %[string range $mom_group_name 0 17] G71"
}


#=============================================================
proc PB_CMD_program_name_set { } {
#=============================================================
# Outputs the first line with program number limited to 18 characters

global mom_group_name mom_operation_name
global gkw_program_name

if { ![info exists mom_group_name] }  {
  set mom_group_name $mom_operation_name
}

# MOM_output_literal "%[string range $mom_group_name 0 17] G71"

set gkw_program_name [string range $mom_group_name 0 17]
}


#=============================================================
proc PB_CMD_rapid_move { } {
#=============================================================
MOM_do_template rapid_traverse
VNC_rapid_xyz
}


#=============================================================
proc PB_CMD_reset_c-axis { } {
#=============================================================
# Resets the custom calulated C-axis when it violates the limit.

global C Cold Cadd C_sim_old_pos
global mom_programmed_feed_rate

set Cnew [expr $C-$Cadd]
if { $Cnew < 0.0 || $Cnew > 360.0 } {MOM_abort "Reset Angle Failed"}

#if {$mom_programmed_feed_rate != 0.0} {
#  set C $Cold
#  MOM_output_literal "M126"
#  MOM_suppress once X Y Z
#  MOM_do_template rapid_traverse
#  MOM_output_literal "M127"
#}

MOM_output_literal "M94"

set C $Cnew
set Cold [expr $Cold -$Cadd]
set C_sim_old_pos [expr $C_sim_old_pos -$Cadd]
set Cadd 0
}


#=============================================================
proc PB_CMD_reset_prev_pos { } {
#=============================================================
global mom_prev_pos

    set mom_prev_pos(0) -9999.
    set mom_prev_pos(1) -9999.
    set mom_prev_pos(2) 9999.
}


#=============================================================
proc PB_CMD_save_last_z { } {
#=============================================================
# capture previous z height for use in cycles
# can't always use the simple mom_prev_pos in cycles so need
# a dedicated variable

global mom_pos
global js_prev_pos			   ;# diy previous Z height	

 if {[hiset mom_pos(2)]} {
	set js_prev_pos $mom_pos(2)
 } else {
	set js_prev_pos 0		   ;# irrelevant if not yet set
 }
}


#=============================================================
proc PB_CMD_set_initial_MSYS { } {
#=============================================================
# This procedure is storing the first MSYS matrix in a array called 
# gkw_init_msys_matrix gkw_init_msys_origin
#

global mom_msys_matrix mom_msys_origin
global gkw_init_msys_matrix gkw_init_msys_origin

# copy matrix

array set gkw_init_msys_matrix [array get mom_msys_matrix]

# copy origin

array set gkw_init_msys_origin [array get mom_msys_origin]

#MOM_output_literal "Output MSYS"
#for {set i 0} {$i <= 8} {incr i}  {
#  MOM_output_literal $gkw_init_msys_matrix($i)
#}
#for {set i 0} {$i <= 2} {incr i}  {
#  MOM_output_literal $gkw_init_msys_origin($i)
#}
}


#=============================================================
proc PB_CMD_set_kinematics { } {
#=============================================================
# This procedure sets the kinematics back to a 3 axis machine.
# This is done to avoid that the AKM library is calculating the (wrong) angles for the B and C axis
# Extra procedures are added to calculate the correct axis values

uplevel #0  {
  set mom_kin_machine_type                      "3_axis_mill"
}

MOM_reload_kinematics
}


#=============================================================
proc PB_CMD_set_position_for_tool_change { } {
#=============================================================
#
#  This custom command creates the part of the program that resets the G80 (cycle 19)
#  

MOM_output_literal "G98 L198"
MOM_output_literal "; SET POSITION FOR TOOL CHANGE"
MOM_output_literal "G00 Z-0. M91"
MOM_output_literal "G00 X-500. M91"
MOM_output_literal "G00 Y0. M91"
MOM_output_literal "G00 B45."
MOM_output_literal "G98 L0"
}


#=============================================================
proc PB_CMD_start_of_alignment_character { } {
#=============================================================
 # This command can be used to output a special sequence number character.  
 # Replace the ":" with any character that you require.
 # You must use the command "PB_CMD_end_of_alignment_character" to reset
 # the sequence number back to the original setting.

  global mom_sys_leader saved_seq_num
  set saved_seq_num $mom_sys_leader(N)
  set mom_sys_leader(N) ":"
}


#=============================================================
proc PB_CMD_start_of_operation_force_addresses { } {
#=============================================================
  MOM_force once S M_spindle X Y Z F G_motion
}


#=============================================================
proc PB_CMD_start_of_operation_motion { } {
#=============================================================
# This command forces/suppresses adresses for the first motion
# An additional motion is output, based on the level of the previous one
# This is done, because the rapid splitup is not done in the rapid block

global mom_programmed_feed_rate
global mom_pos mom_prev_pos
global gkw_tpcm_mode
#global gkw_first_move

if {$gkw_tpcm_mode == 128} return


#if { $mom_pos(2) < $mom_prev_pos(2) || ![info exists gkw_first_move]} {
  MOM_force once G_motion X Y M_spindle F cutter_comp M_coolant
  MOM_suppress once Z
  if { $mom_programmed_feed_rate == 0.0 } {
    MOM_do_template rapid_traverse
    PB_CMD_SIM_rapid_xy
  } else {
    MOM_do_template linear_move_1
    PB_CMD_SIM_linear_move_xy
  }
  MOM_force once Z
#} else {
#  MOM_force once G_motion Z M_spindle F cutter_comp M_coolant
#  MOM_suppress once X Y
#  if { $mom_programmed_feed_rate == 0.0 } {
#    MOM_do_template rapid_traverse
#    PB_CMD_SIM_rapid_z
#  } else {
#    MOM_do_template linear_move_1
#    PB_CMD_SIM_linear_move_z
#  }
#  MOM_force once X Y
#}

#set gkw_first_move 1
}


#=============================================================
proc PB_CMD_suppress_Z { } {
#=============================================================
MOM_force off Z
MOM_suppress always Z
}


#=============================================================
proc PB_CMD_tool_change_force_addresses { } {
#=============================================================
  MOM_force once G_adjust H
}


#=============================================================
proc PB_CMD_tool_init { } {
#=============================================================
# output label and comment comment line with label number and toolname

global mom_tool_name
global mom_tool_number
global gkw_label_number
global gkw_label_index
global mom_sys_control_out
global gkw_new_tool
global C

if {![info exists gkw_label_index]}  {
  set gkw_label_index 1
}

set gkw_label_number $gkw_label_index

MOM_do_template label_output

MOM_output_literal "$mom_sys_control_out $gkw_label_index #T$mom_tool_number=$mom_tool_name"

incr gkw_label_index
set gkw_new_tool 1
set C 0
}


#=============================================================
proc PB_CMD_transform_coord { } {
#=============================================================
#_______________________________________________________________________________
# transform the coordinates xyz to xf yf zf using the angles B and C
#_______________________________________________________________________________
#
global xi yi zi xf yf zf
global B C
global vi vj
global pi
global alfa A
global x1 y1 z1
global x2 y2 z2
global x3 y3 z3
global x4 y4 z4
global tipo_angulo

set tipo_angulo 1

	set B [expr $B*$pi/180]
	set C [expr 0-$C*$pi/180]

#Rotation C
	set vi $xi
	set vj $yi
	PB_CMD_calculate_alpha
	set x1 [expr $A*cos($alfa+$C)]
	set y1 [expr $A*sin($alfa+$C)]
	set z1 $zi
	#MOM_output_literal "xi $xi yi $yi"
	#MOM_output_literal "alfa $alfa A $A"
	#MOM_output_literal "Rotation C x1 $x1 y1 $y1 z1 $z1"

#Rotate 45 degrees
	set vi $y1
	set vj $z1
	PB_CMD_calculate_alpha
	set x2 $x1
	set y2 [expr $A*cos($pi/4-$alfa)]
	set z2 [expr 0 - $A*sin($pi/4-$alfa)]
	#MOM_output_literal "alfa $alfa A $A"
	#MOM_output_literal "Rotation 45 $x2 $y2 $z2"

#Rotation B
	set vi $x2
	set vj $y2
	PB_CMD_calculate_alpha
	set x3 [expr $A*cos($alfa+$B)]
	set y3 [expr $A*sin($alfa+$B)]
	set z3 $z2
	#MOM_output_literal "alfa $alfa A $A"
	#MOM_output_literal "Rotation B $x3 $y3 $z3"

#Rotate -45 degrees, to original coordinate system
	set vi $y3
	set vj $z3
	PB_CMD_calculate_alpha
	set x4 $x3
	set y4 [expr $A*cos($pi/4+$alfa)]
	set z4 [expr $A*sin($pi/4+$alfa)]
	#MOM_output_literal "alfa $alfa A $A"
	#MOM_output_literal "Rotation -45 $x4 $y4 $z4"

set xf $x4
set yf $y4
set zf $z4

set B [expr $B*180/$pi]
set C [expr 0-$C*180/$pi]
}


#=============================================================
proc PB_CMD_unclamp_fourth_axis { } {
#=============================================================
#
#  This procedure is used by auto clamping to output the code
#  needed to unclamp the fourth axis.  
#
#  Do NOT add this block to events or markers.  It is a static 
#  block and it is not intended to be added to events.  Do NOT 
#  change the name of this custom command.
#
  MOM_output_literal "M11"
}


#=============================================================
proc PB_CMD_unsuppress_Z { } {
#=============================================================
MOM_suppress off Z
}


#=============================================================
proc PB_CMD_write_stored_work_planes { } {
#=============================================================
# writes out all the workplanes that are stored in gkw_work_plane(200,11) 

global gkw_work_plane_index
global gkw_work_plane
global gkw_rel_msys gkw_alpha gkw_beta gkw_gamma
global mom_sys_control_out
global gkw_label_number
global gkw_label_call_number


set gkw_label_call_number 199

set index [expr 199+[array size gkw_work_plane]/12]

for {set i 200} {$i <= $index } {incr i}  {

  set gkw_label_number $i
  MOM_do_template label_output
  MOM_output_literal "$mom_sys_control_out $i # Workplane number [expr $i - 199]"
  get_matrix gkw_rel_msys gkw_work_plane $i
  MSYS2MAT square_msys_matrix gkw_rel_msys
  calculate_cycle_19_angles gkw_rel_msys gkw_alpha gkw_beta gkw_gamma
  MOM_do_template label_call_output
#  MOM_force once G_motion Z M
#  MOM_do_template rapid_z_to_machine_coord
#  MOM_force once G_motion X Y M
#  MOM_do_template rapid_xy_to_machine_coord
  MOM_do_template datum_shift_def
  MOM_do_template datum_sel
  MOM_do_template datum_shift_def
  MOM_force once X Y Z
  MOM_do_template datum_shift_ix
  MOM_do_template datum_shift_iy
  MOM_do_template datum_shift_iz
  if {[expr abs($gkw_alpha)] >= 0.001 || [expr abs($gkw_beta)] >= 0.001 || [expr abs($gkw_gamma)] >= 0.001 }  {
    MOM_do_template work_plane_def
    MOM_do_template work_plane_angles
  }
  MOM_do_template set_table_angles
  set gkw_label_number 0
  MOM_do_template label_output
}
}


#=============================================================
proc DELAY_TIME_SET {  } {
#=============================================================
  global mom_sys_delay_param mom_delay_value
  global mom_delay_revs mom_delay_mode delay_time
 
   # post builder provided format for the current mode:
    if {[info exists mom_sys_delay_param(${mom_delay_mode},format)] != 0} {
      MOM_set_address_format dwell $mom_sys_delay_param(${mom_delay_mode},format)
    }
 
    switch $mom_delay_mode {
      SECONDS {set delay_time $mom_delay_value}
      default {set delay_time $mom_delay_revs}
    }
}


#=============================================================
proc LOCK_AXIS { input_point output_point output_rotary } {
#=============================================================
  upvar $input_point ip ; upvar $output_point op ; upvar $output_rotary or

  global mom_kin_4th_axis_center_offset mom_kin_5th_axis_center_offset
  global mom_pos mom_kin_4th_axis_plane mom_kin_5th_axis_plane    
  global mom_sys_lock_value mom_sys_lock_plane
  global mom_sys_lock_axis mom_sys_lock_status
  global mom_out_angle_pos mom_prev_out_angle_pos mom_kin_4th_axis_direction 
  global mom_kin_5th_axis_direction mom_kin_4th_axis_leader mom_kin_5th_axis_leader
  global mom_sys_leader 
  global DEG2RAD RAD2DEG
 
   if {$mom_sys_lock_status == "OFF"} {
      return
   }
   VEC3_sub ip mom_kin_4th_axis_center_offset temp
   if [info exists mom_kin_5th_axis_center_offset] {
      VEC3_sub temp mom_kin_5th_axis_center_offset temp
   }
   set temp(3) $ip(3)
   set temp(4) $ip(4)

   if {$mom_sys_lock_plane == -1} {
      if {$mom_kin_4th_axis_plane == "XY"} {
         set mom_sys_lock_plane 2
      } elseif {$mom_kin_4th_axis_plane == "ZX"} {
         set mom_sys_lock_plane 1
      } elseif {$mom_kin_4th_axis_plane == "YZ"} {
         set mom_sys_lock_plane 0
      }
   } 

   if {$mom_kin_4th_axis_plane == "XY"} {
      set fourth_axis 2
   } elseif {$mom_kin_4th_axis_plane == "ZX"} {
      set fourth_axis 1
   } elseif {$mom_kin_4th_axis_plane == "YZ"} {
      set fourth_axis 0
   }

   if {[info exists mom_kin_5th_axis_plane]} {
      if {$mom_kin_5th_axis_plane == "XY"} {
         set fifth_axis 2
      } elseif {$mom_kin_5th_axis_plane == "ZX"} {
         set fifth_axis 1
      } elseif {$mom_kin_5th_axis_plane == "YZ"} {
         set fifth_axis 0
      }
   } else {
      set fifth_axis -1
   }


   if {$mom_sys_lock_axis > 2} {
      set angle [expr ($mom_sys_lock_value-$temp($mom_sys_lock_axis))*$DEG2RAD]
      ROTATE_VECTOR $mom_sys_lock_plane $angle temp temp1
      VMOV 3 temp1 temp
      set temp($mom_sys_lock_axis) $mom_sys_lock_value
   } else {
      if {$mom_sys_lock_plane == 0} {
         set i1 1
         set i2 2
      } elseif {$mom_sys_lock_plane == 1} {
         set i1 2
         set i2 0
      } elseif {$mom_sys_lock_plane == 2} {
         set i1 0
         set i2 1
      }
      set unlocked_axis [expr $i1 + $i2 - $mom_sys_lock_axis]
      set rad [expr sqrt($temp($i1)*$temp($i1) + $temp($i2)*$temp($i2))]
      set angle [ARCTAN $temp($i2) $temp($i1)]
      if { $rad < [expr abs($mom_sys_lock_value)]} {
         if {$mom_sys_lock_value < 0.0} {
            set temp($mom_sys_lock_axis) [expr -$rad]
         } else {
            set temp($mom_sys_lock_axis) $rad
         }
      } else {
         set temp($mom_sys_lock_axis) $mom_sys_lock_value
      }

      set temp($unlocked_axis)  [expr sqrt($rad*$rad - $temp($mom_sys_lock_axis)*$temp($mom_sys_lock_axis))]

      if {$mom_sys_lock_plane == $fourth_axis || $mom_sys_lock_plane == $fifth_axis} {
         VMOV 5 temp temp1
         set temp1($unlocked_axis) [expr -$temp($unlocked_axis)]
         set ang1 [ARCTAN $temp($i2) $temp($i1)]
         set ang2 [ARCTAN $temp1($i2) $temp1($i1)]
         if {$mom_sys_lock_plane == $fourth_axis} {
            set i1 3
         } else {
            set i1 4
         }
         set temp($i1) [expr ($angle-$ang1)*$RAD2DEG]
         set temp1($i1) [expr ($angle-$ang2)*$RAD2DEG]
         set ang1 [LIMIT_ANGLE [expr $ip($i1)-$temp($i1)]]
         set ang2 [LIMIT_ANGLE [expr $ip($i1)-$temp1($i1)]]
         if {$ang1 > 180.0} {set ang1 [LIMIT_ANGLE [expr -$ang1]]}  
         if {$ang2 > 180.0} {set ang2 [LIMIT_ANGLE [expr -$ang2]]}
         if {$ang1 > $ang2} {VMOV 5 temp1 temp}
      }
   }

   VEC3_add temp mom_kin_4th_axis_center_offset op
   if {[info exists mom_kin_5th_axis_center_offset]} {
      VEC3_add op mom_kin_5th_axis_center_offset op
   }

   if {![info exists or]} {
      set or(0) 0.0
      set or(1) 0.0
   }
   if {![info exists mom_prev_out_angle_pos]} {
      set mom_prev_out_angle_pos(0) $or(0)
      set mom_prev_out_angle_pos(1) $or(1)
   }

   set or(0) [ROTSET $temp(3) $mom_prev_out_angle_pos(0) $mom_kin_4th_axis_direction $mom_kin_4th_axis_leader mom_sys_leader(fourth_axis)]
   if {[info exists mom_kin_5th_axis_direction]} {
      set or(1) [ROTSET $temp(4) $mom_prev_out_angle_pos(1) $mom_kin_5th_axis_direction $mom_kin_5th_axis_leader mom_sys_leader(fifth_axis)]
   }

   set op(3) $temp(3)
   set op(4) $temp(4)
}



proc IJK2AlphaBeta { i j k a b } {
# IJK2AlphaBeta
# Calulates Alpha (a) and Beta (b) angles in Degrees based on a vector i, j, k
# The values are returned to the arguments a (Alpha) and b (Beta)
# Input : i j k
# Output: -180 <= a <= 180
#          -90 <= b <= 90

	upvar 1 $a Alpha
	upvar 1 $b Beta

	set pi [ expr asin(1) * 2]
	
	# Alpha value
	set Alpha [expr (atan2($j,$i))*180/$pi] ; 

  # Clarify undefined status
	if { $i == 0 && $j == 0} { set Alpha 0} ; 
  
  # Beta value
  if { $k < 0.0 } {	
    set Beta [expr (90-(acos(abs($k))*180/$pi))*-1]
  } else {
    set Beta [expr 90-(acos(abs($k))*180/$pi)]
  }
}


#=============================================================
proc CALC_CYLINDRICAL_RETRACT_POINT { refpt axis dist ret_pt } {
#=============================================================
  upvar $refpt rfp ; upvar $axis ax ; upvar $ret_pt rtp 

#
# return 0 parallel or lies on plane
#        1 unique intersection
#


#
# create plane canonical form
#
  VMOV 3 ax plane
  set plane(3) $dist

  set num [expr $plane(3)-[VEC3_dot rfp plane]]
  set dir [VEC3_dot ax plane]
  if {[EQ_is_zero $dir]} {return 0}
  for {set i 0} {$i < 3} {incr i} {
    set rtp($i) [expr $rfp($i) + $ax($i)*$num/$dir]
  }
  return [RETRACT_POINT_CHECK rfp ax rtp]
}


#=============================================================
proc REPOSITION_ERROR_CHECK { warn } {
#=============================================================
  global mom_kin_4th_axis_max_limit mom_kin_4th_axis_min_limit 
  global mom_kin_5th_axis_max_limit mom_kin_5th_axis_min_limit 
  global mom_pos mom_prev_pos mom_alt_pos mom_alt_prev_pos
  global mom_sys_rotary_error mom_warning_info mom_kin_machine_type

  if {$warn != "secondary rotary position being used" || [string index $mom_kin_machine_type 0] != 5} {
    set mom_sys_rotary_error $warn
    return
  }

  set mom_sys_rotary_error 0

  set a4 [expr $mom_alt_pos(3)+360.0]
  set a5 [expr $mom_alt_pos(4)+360.0]
  while {[expr $a4-$mom_kin_4th_axis_min_limit] > 360.0} {set a4 [expr $a4-360.0]}
  while {[expr $a5-$mom_kin_5th_axis_min_limit] > 360.0} {set a5 [expr $a5-360.0]}
  if {$a4 <= $mom_kin_4th_axis_max_limit && $a5 <= $mom_kin_5th_axis_max_limit} {return}

  for {set i 0} {$i < 2} {incr i} {
    set rot($i) [expr $mom_pos([expr $i+3]) - $mom_prev_pos([expr $i+3])]
    while {$rot($i) > 180.0} {set rot($i) [expr $rot($i)-360.0]}
    while {$rot($i) < 180.0} {set rot($i) [expr $rot($i)+360.0]}
    set rot($i) [expr abs($rot($i))]

    set rotalt($i) [expr $mom_alt_pos([expr $i+3]) - $mom_prev_pos([expr $i+3])]
    while {$rotalt($i) > 180.0} {set rotalt($i) [expr $rotalt($i)-360.0]}
    while {$rotalt($i) < 180.0} {set rotalt($i) [expr $rotalt($i)+360.0]}
    set rotalt($i) [expr abs($rotalt($i))]
  }

  if {[EQ_is_equal [expr $rot(0)+$rot(1)] [expr $rotalt(0)+$rotalt(1)]]} {return}
  set mom_sys_rotary_error $warn
}


#=============================================================
proc CATCH_WARNING { msg } {
#=============================================================
  global mom_warning_info
  global mom_motion_event
  global mom_event_number

   set level [info level]
   set call_stack ""
   for {set i 1} {$i < $level} {incr i} {
      set call_stack "$call_stack\[ [lindex [info level $i] 0] \]"
   }
   set mom_warning_info "$msg ($mom_motion_event $mom_event_number) $call_stack"
   MOM_catch_warning
}


#=============================================================
proc AXIS_SET { axis } {
#=============================================================

  global mom_sys_leader

   if {$axis == "[string index $mom_sys_leader(fourth_axis) 0]AXIS"} {
      return 3
   } elseif {$axis == "[string index $mom_sys_leader(fifth_axis) 0]AXIS"} {
      return 4
   }
}


#=============================================================
proc CALC_SPHERICAL_RETRACT_POINT { refpt axis cen_sphere rad_sphere int_pts } {
#=============================================================

  upvar $refpt rp ; upvar $axis ta ; upvar $cen_sphere cs 
  upvar $int_pts ip  

   set rad [expr $rad_sphere*$rad_sphere]
   VEC3_sub rp cs v1

   set coeff(2) 1.0
   set coeff(1) [expr ($v1(0)*$ta(0) + $v1(1)*$ta(1) + $v1(2)*$ta(2))*2.0]
   set coeff(0) [expr $v1(0)*$v1(0) + $v1(1)*$v1(1) + $v1(2)*$v1(2) - $rad]

   set num_sol [SOLVE_QUADRATIC coeff roots iroots status degree]
   if {$num_sol == 0} {return 0}

   if {[expr $roots(0)] > [expr $roots(1)] || $num_sol == 1} {
      set d $roots(0)
   } else {
      set d $roots(1)
   }
   set ip(0) [expr $rp(0) + $d*$ta(0)]
   set ip(1) [expr $rp(1) + $d*$ta(1)]
   set ip(2) [expr $rp(2) + $d*$ta(2)]

return [RETRACT_POINT_CHECK rp ta ip]
}


#=============================================================
proc SOLVE_QUADRATIC { coeff rcomp icomp status degree } {
#=============================================================

  upvar $coeff c ; upvar $rcomp rc ; upvar $icomp ic
  upvar $status st ; upvar $degree deg 

   set st 1
   set deg 0
   set rc(0) 0.0 ; set rc(1) 0.0
   set ic(0) 0.0 ; set ic(1) 0.0
   set mag [VEC3_mag c]
   if {[EQ_is_zero $mag]} {return 0}
   set acoeff [expr $c(2)/$mag]
   set bcoeff [expr $c(1)/$mag]
   set ccoeff [expr $c(0)/$mag]
   if {![EQ_is_zero $acoeff]} {
      set deg 2
      set denom [expr $acoeff*2.]
      set dscrm [expr $bcoeff*$bcoeff - $acoeff*$ccoeff*4.0]
      if {[EQ_is_zero $dscrm]} {
         set dsqrt1 0.0
      } else {
         set dsqrt1 [expr sqrt(abs($dscrm))]
      }
      if {[EQ_is_ge $dscrm 0.0]} {
         set rc(0) [expr (-$bcoeff + $dsqrt1)/$denom]
         set rc(1) [expr (-$bcoeff - $dsqrt1)/$denom]
         set st 3
         return 2
      } else {
         set rc(0) [expr -$bcoeff/$denom]
         set rc(1) $rc(0)
         set ic(0) [expr $dsqrt1/$denom]
         set ic(1) $ic(0)
         set st 2
         return 0
      }
   } elseif {![EQ_is_zero $bcoeff] } {
      set st 3
      set deg 1
      set rc(0) [expr -$ccoeff/$bcoeff]
      return 1
   } elseif {[EQ_is_zero $ccoeff] } {
      return 0
   } else {
      return 0
   }
}


#=============================================================
proc LOCK_AXIS_MOTION {  } {
#=============================================================
#
#  The UDE lock_axis must be specified in the tool path
#  for the post to lock the requested axis.  The UDE lock_axis may only
#  be used for four and five axis machine tools.  A four axis post may
#  only lock an axis in the plane of the fourth axis.  If you have a
#  five axis machine you must specify a plane since there are two 
#  possible planes.
#
  global mom_pos mom_out_angle_pos mom_current_motion mom_motion_type
  global mom_cycle_feed_to_pos mom_cycle_feed_to mom_tool_axis
  global mom_motion_event mom_sys_lock_status 
  global mom_cycle_rapid_to_pos mom_cycle_retract_to_pos
  global mom_cycle_rapid_to mom_cycle_retract_to 

  if {$mom_sys_lock_status == "ON"} {  
    if {$mom_current_motion != "circular_move"} {
      LOCK_AXIS mom_pos mom_pos mom_out_angle_pos
      MOM_reload_variable -a mom_out_angle_pos
      if {$mom_motion_type == "CYCLE"} {
        if {$mom_motion_event == "initial_move"} {
           set mom_pos(0) [expr $mom_pos(0) - $mom_cycle_rapid_to * $mom_tool_axis(0)]
           set mom_pos(1) [expr $mom_pos(1) - $mom_cycle_rapid_to * $mom_tool_axis(1)]
           set mom_pos(2) [expr $mom_pos(2) - $mom_cycle_rapid_to * $mom_tool_axis(2)]
        }
        set mom_cycle_feed_to_pos(0) [expr $mom_pos(0) + $mom_cycle_feed_to * $mom_tool_axis(0)]
        set mom_cycle_feed_to_pos(1) [expr $mom_pos(1) + $mom_cycle_feed_to * $mom_tool_axis(1)]
        set mom_cycle_feed_to_pos(2) [expr $mom_pos(2) + $mom_cycle_feed_to * $mom_tool_axis(2)]    
 
        set mom_cycle_rapid_to_pos(0) [expr $mom_pos(0) + $mom_cycle_rapid_to * $mom_tool_axis(0)]
        set mom_cycle_rapid_to_pos(1) [expr $mom_pos(1) + $mom_cycle_rapid_to * $mom_tool_axis(1)]
        set mom_cycle_rapid_to_pos(2) [expr $mom_pos(2) + $mom_cycle_rapid_to * $mom_tool_axis(2)]    
 
        set mom_cycle_retract_to_pos(0) [expr $mom_pos(0) + $mom_cycle_retract_to * $mom_tool_axis(0)]
        set mom_cycle_retract_to_pos(1) [expr $mom_pos(1) + $mom_cycle_retract_to * $mom_tool_axis(1)]
        set mom_cycle_retract_to_pos(2) [expr $mom_pos(2) + $mom_cycle_retract_to * $mom_tool_axis(2)]    
      }
    }
  }
}


#=============================================================
proc LOCK_AXIS_SUB { axis } {
#=============================================================
  global mom_pos mom_lock_axis_value_defined mom_lock_axis_value

   if {$mom_lock_axis_value_defined == 1} {
      return $mom_lock_axis_value 
   } else {
      return $mom_pos($axis)
   }
}


#=============================================================
proc WORKPLANE_SET {  } {
#=============================================================
   global mom_cycle_spindle_axis
   global mom_sys_spindle_axis
   global traverse_axis1 traverse_axis2

   if { ![info exists mom_sys_spindle_axis] } {
      set mom_sys_spindle_axis(0) 0.0
      set mom_sys_spindle_axis(1) 0.0
      set mom_sys_spindle_axis(2) 1.0
   }

   if { ![info exists mom_cycle_spindle_axis] } {
      set x $mom_sys_spindle_axis(0)
      set y $mom_sys_spindle_axis(1)
      set z $mom_sys_spindle_axis(2)

      if { [EQ_is_zero $y] && [EQ_is_zero $z] } {
         set mom_cycle_spindle_axis 0
      } elseif { [EQ_is_zero $x] && [EQ_is_zero $z] } {
         set mom_cycle_spindle_axis 1
      } else {
         set mom_cycle_spindle_axis 2
      }
   }

   if { $mom_cycle_spindle_axis == 2 } {
      set traverse_axis1 0 ; set traverse_axis2 1
   } elseif { $mom_cycle_spindle_axis == 0 } {
      set traverse_axis1 1 ; set traverse_axis2 2
   } elseif { $mom_cycle_spindle_axis == 1 } {
      set traverse_axis1 0 ; set traverse_axis2 2
   }
}


#=============================================================
proc SET_LOCK { axis plane value } {
#=============================================================
  upvar $axis a ; upvar $plane p ; upvar $value v

  global mom_kin_machine_type mom_lock_axis mom_lock_axis_plane mom_lock_axis_value
  global mom_warning_info

   switch $mom_kin_machine_type {
      4_axis_head -
      4_AXIS_HEAD -
      4_axis_table -
      4_AXIS_TABLE -
      mill_turn -
      MILL_TURN            {set mtype 4}
      5_axis_dual_table -
      5_AXIS_DUAL_TABLE -
      5_axis_dual_head -
      5_AXIS_DUAL_HEAD -
      5_axis_head_table -
      5_AXIS_HEAD_TABLE    {set mtype 5}
      default { 
         set mom_warning_info "Set lock only vaild for 4 and 5 axis machines"
         return "error"
      }
   } 

   set p -1          

   switch $mom_lock_axis {
      OFF {
         return "OFF"
      }
      XAXIS {
         set a 0
         switch $mom_lock_axis_plane {
            XYPLAN {
               set v [LOCK_AXIS_SUB $a]
               set p 2 
            }
            YZPLAN {
               set mom_warning_info "Invalid plane for lock axis"
               return "error"
            }
            ZXPLAN {
               set v [LOCK_AXIS_SUB $a]
               set p 1 
            }
            NONE {
               if {$mtype == 5} {
                  set mom_warning_info "Must specify lock axis plane for 5 axis machine"
                  return "error"
               } else {
                  set v [LOCK_AXIS_SUB $a]
               }
            }
         }
      }
      YAXIS {
         set a 1
         switch $mom_lock_axis_plane {
            XYPLAN {
               set v [LOCK_AXIS_SUB $a]
               set p 2 
            }
            YZPLAN {
               set v [LOCK_AXIS_SUB $a]
               set p 0 
            }
            ZXPLAN {
               set mom_warning_info "Invalid plane for lock axis"
               return "error"
            }
            NONE {
               if {$mtype == 5} {
                  set mom_warning_info "Must specify lock axis plane for 5 axis machine"
                  return "error"
               } else {
                  set v [LOCK_AXIS_SUB $a]
               }
            }
         }               
      }
      ZAXIS {
         set a 2
         switch $mom_lock_axis_plane {
            YZPLAN {
               set v [LOCK_AXIS_SUB $a]
               set p 0 
            }
            ZXPLAN {
               set v [LOCK_AXIS_SUB $a] 
               set p 1 
            }
            XYPLAN {
               set mom_warning_info "Invalid plane for lock axis"
               return "error"
            }
            NONE {
               if {$mtype == 5} {
                  set mom_warning_info "Must specify lock axis plane for 5 axis machine"
                  return "error"
               } else {
                  set v [LOCK_AXIS_SUB $a]
               }
            }
         }               
      }
      FOURTH {
         set a 3
         set v [LOCK_AXIS_SUB $a]
      }
      FIFTH {
         set a 4
         set v [LOCK_AXIS_SUB $a] 
      }   
      AAXIS {
         set a [AXIS_SET $mom_lock_axis]
         set v [LOCK_AXIS_SUB $a]
      }
      BAXIS {
         set a [AXIS_SET $mom_lock_axis]
         set v [LOCK_AXIS_SUB $a]
      }
      CAXIS {
         set a [AXIS_SET $mom_lock_axis]
         set v [LOCK_AXIS_SUB $a]
      }
   }

return "ON"
}


#=============================================================
proc ARCTAN { y x } {
#=============================================================
  global PI

   if {[EQ_is_zero $y]} {
      if {$x < 0.0} { return $PI }

      return 0.0
   }
   if {[EQ_is_zero $x]} {
      if {$y < 0.0} {return [expr $PI*1.5]}
      return [expr $PI*.5]
   }
   set ang [expr atan ($y/$x)]
   if {$x > 0.0 && $y < 0.0} {return [expr $ang+$PI*2.0]}
   if {$x < 0.0 && $y < 0.0} {return [expr $ang+$PI]}
   if {$x < 0.0 && $y > 0.0} {return [expr $ang+$PI]}

return $ang
}




#=============================================================
proc ROTATE_VECTOR { plane angle input_vector output_vector } {
#=============================================================
  upvar $output_vector v ; upvar $input_vector v1

   if {$plane == 0} {
      set v(0) $v1(0)
      set v(1) [expr $v1(1)*cos($angle) - $v1(2)*sin($angle)]
      set v(2) [expr $v1(2)*cos($angle) + $v1(1)*sin($angle)]
   } elseif {$plane == 1} {
      set v(0) [expr $v1(0)*cos($angle) + $v1(2)*sin($angle)]
      set v(1) $v1(1)
      set v(2) [expr $v1(2)*cos($angle) - $v1(0)*sin($angle)]
   } elseif {$plane == 1} {
      set v(0) [expr $v1(0)*cos($angle) - $v1(1)*sin($angle)]
      set v(1) [expr $v1(1)*cos($angle) + $v1(0)*sin($angle)]
      set v(2) $v1(2)
   }
}


#=============================================================
proc ROTSET { angle prev_angle dir kin_leader sys_leader } {
#=============================================================

#  This procedure will take an input angle and format for a specific machine.
#
#  angle	angle to be output.
#  prev_angle	previous angle out.  It should be mom_out_angle_pos
#  dir		can be either MAGNITUDE_DETERMINES_DIRECTION or 
#		SIGN_DETERMINES_DIRECTION
#  kin_leader	leader (usually A, B or C) defined by postbuilder
#  sys_leader   leader that is created by rotset.  It could be C-.
#
  upvar $sys_leader lead

   while {$angle < 0.0} {set angle [expr $angle+360.0]}
   while {$angle >= 360.0} {set angle [expr $angle-360.0]}

   if {$dir == "MAGNITUDE_DETERMINES_DIRECTION"} {
      while {[expr abs([expr $angle-$prev_angle])] > 180.0} {
         if {[expr $angle-$prev_angle] < -180.0} {
            set angle [expr $angle+360.0]
         } elseif {[expr $angle-$prev_angle] > 180.0} {
            set angle [expr $angle-360.0]
         }
      }
   } elseif {$dir == "SIGN_DETERMINES_DIRECTION"} {
      set del [expr $angle-$prev_angle]
      if {($del < 0.0 && $del > -180.0) || $del > 180.0} {
         set lead "$kin_leader-"
      } else {
         set lead $kin_leader
      } 
   }

return $angle
}


#=============================================================
proc LIMIT_ANGLE { a } {
#=============================================================

   while {$a < 0.0} {set a [expr $a+360.0]}
   while {$a >= 360.0} {set a [expr $a-360.0]}	

return $a
}


#=============================================================
proc EQ_is_zero { s } {
#=============================================================
   global mom_system_tolerance

   if [info exists mom_system_tolerance] {
      if { [expr abs($s)] <= $mom_system_tolerance } { return 1 } else { return 0 }
   } else {
      return 0
   }
}


#=============================================================
proc VMOV { n p1 p2 } {
#=============================================================
  upvar $p1 v1 ; upvar $p2 v2

   for {set i 0} {$i < $n} {incr i} {
      set v2($i) $v1($i)
   }
}


#=============================================================
proc EQ_is_equal { s t } {
#=============================================================
   global mom_system_tolerance

   if [info exists mom_system_tolerance] {
      if { [expr abs($s - $t)] <= $mom_system_tolerance } { return 1 } else { return 0 }
   } else {
      return 0
   }
}


#=============================================================
proc AUTO_CLAMP {  } {
#=============================================================
#
#  This procedure is used to automaticaaly output clamp and unclamp
#  codes.  This procedure must be placed in the the procedure
#  << PB_CMD_kin_before_motion >>.  By default this procedure will
#  output M10 or M11 to do the clamping and unclamping.
#
   global clamp_rotary_status mom_pos mom_prev_pos mom_sys_auto_clamp

   if {![info exists mom_sys_auto_clamp]} {return}
   if {$mom_sys_auto_clamp != "ON"} {return}

   if {![info exists clamp_rotary_status]} {set clamp_rotary_status "UNDEFINED"}

   set rotary_out [EQ_is_equal $mom_pos(3) $mom_prev_pos(3)]

   if {$rotary_out  == 0 && $clamp_rotary_status != "UNCLAMPED"} {
      PB_CMD_unclamp_fourth_axis
      set clamp_rotary_status "UNCLAMPED"
   } elseif {$rotary_out == 1 && $clamp_rotary_status != "CLAMPED"} {
      PB_CMD_clamp_fourth_axis
      set clamp_rotary_status "CLAMPED"
   }
}




#=============================================================
proc RETRACT_POINT_CHECK { refpt axis retpt } {
#=============================================================
  upvar $refpt rfp ; upvar $axis ax ; upvar $retpt rtp 

# 
#  determine if retraction point is "below" the retraction plane
#  if the tool is already in a safe position, do not retract
#
#  return 0	no retract needed
#         1     retraction needed
#

  VEC3_sub rtp rfp vec
  if {[VEC3_is_zero vec]} {return 0}
  set x [VEC3_unitize vec vec1]
  set dir [VEC3_dot ax vec1]
  if {$dir <= 0.0} {
    return 0
  } else {
    return 1
  }
}


#=============================================================
proc ROTARY_AXIS_RETRACT {  } {
#=============================================================
#
#  This procedure is used by four and five axis posts to retract
#  from the part when the rotary axis become discontinuous.  This
#  procedure must be placed in the MOM_before_motion event.  
#
  global mom_kin_retract_plane mom_kin_reengage_distance
  global mom_kin_rotary_reengage_feedrate mom_kin_rapid_feed_rate                      
  global mom_sys_rotary_error mom_pos mom_prev_pos 
  global mom_prev_out_angle_pos
  global mom_kin_4th_axis_direction mom_kin_4th_axis_leader 
  global mom_out_angle_pos mom_kin_5th_axis_direction mom_kin_5th_axis_leader 
  global mom_kin_4th_axis_center_offset mom_kin_5th_axis_center_offset
  global mom_sys_leader mom_tool_axis mom_prev_tool_axis mom_kin_4th_axis_type
  global mom_kin_spindle_axis mom_motion_event
  global mom_alt_pos mom_prev_alt_pos mom_feed_rate 
  global mom_kin_rotary_reengage_feedrate 
  global mom_feed_engage_value mom_feed_cut_value
  global mom_kin_4th_axis_limit_action mom_warning_info


   if {[info exists mom_sys_rotary_error] && [info exists mom_motion_event]} {

      if {$mom_sys_rotary_error != 0 && $mom_motion_event == "linear_move"} { 

         if {$mom_kin_4th_axis_limit_action == "Warning"} {
            set mom_warning_info  "Rotary axis limit violated, discontinuos motion may result"
            MOM_catch_warning
            unset mom_sys_rotary_error
            return 
         }


         if {$mom_sys_rotary_error == "ROTARY CROSSING LIMIT." } {
            set roterr 0
         } else {
            set roterr 1
         }

         unset mom_sys_rotary_error

        # Retract from part

         VMOV 5 mom_pos save_pos
         VMOV 5 mom_prev_pos save_prev_pos
         VMOV 2 mom_out_angle_pos save_out_angle_pos
         set save_feedrate $mom_feed_rate

         set cen(0) 0.0
         set cen(1) 0.0
         set cen(2) 0.0
         if [info exists mom_kin_4th_axis_center_offset] {
            VEC3_add cen mom_kin_4th_axis_center_offset cen
         }
         if [info exists mom_kin_5th_axis_center_offset] {
            VEC3_sub cen mom_kin_5th_axis_center_offset cen
         }
         if {$mom_kin_4th_axis_type == "Table"} {
            set num_sol [CALC_CYLINDRICAL_RETRACT_POINT mom_prev_pos mom_kin_spindle_axis $mom_kin_retract_plane ret_pt]
         } else {
            set num_sol [CALC_SPHERICAL_RETRACT_POINT mom_prev_pos mom_prev_tool_axis cen $mom_kin_retract_plane ret_pt]
         }

  
         set mom_feed_rate $mom_kin_rapid_feed_rate                      
         FEEDRATE_SET
  

         if {$num_sol != 0} {
            MOM_suppress once fourth_axis fifth_axis
            VEC3_add ret_pt cen mom_pos
            PB_CMD_linear_move
         }

        #
        # temporary fix for missing mom_prev_out_angle_pos(0)
        #
         if {![info exists mom_prev_out_angle_pos(0)]} {  
            set mom_prev_out_angle_pos(0) [MOM_ask_address_value fourth_axis]
         }
         if {![info exists mom_prev_out_angle_pos(1)]} {  
            set mom_prev_out_angle_pos(1) [MOM_ask_address_value fifth_axis]
         }


         if {$roterr == 0} {
           #
           # unwind table
           #
            if {[info exists mom_kin_4th_axis_direction]} {
               set mom_out_angle_pos(0) [ROTSET $mom_prev_pos(3) $mom_out_angle_pos(0) $mom_kin_4th_axis_direction $mom_kin_4th_axis_leader mom_sys_leader(fourth_axis)]
            }
            if {[info exists mom_kin_5th_axis_direction]} {
               set mom_out_angle_pos(1) [ROTSET $mom_prev_pos(4) $mom_out_angle_pos(1) $mom_kin_5th_axis_direction $mom_kin_5th_axis_leader mom_sys_leader(fourth_axis)]
            }
            MOM_suppress once X Y Z
            PB_CMD_linear_move
            for {set i 0} {$i < 3} {incr i} {
               set mom_pos($i) [expr $mom_prev_pos($i)+$mom_kin_reengage_distance*$mom_kin_spindle_axis($i)]
            }
            MOM_suppress once fourth_axis fifth_axis
            PB_CMD_linear_move
            VMOV 3 mom_prev_pos mom_pos
            MOM_suppress once fourth_axis fifth_axis
            if {$mom_feed_engage_value  > 0.0} {
               set mom_feed_rate $mom_feed_engage_value  
            } elseif {$mom_feed_cut_value  > 0.0} {
               set mom_feed_rate $mom_feed_cut_value  
            } else {
               set mom_feed_rate 10.0
            }
            FEEDRATE_SET
            PB_CMD_linear_move
            VMOV 5 save_pos mom_pos
            VMOV 5 save_prev_pos mom_prev_pos
            VMOV 2 save_out_angle_pos mom_out_angle_pos
         } else {
           #
           # move to alternate rotary position
           #
            set mom_out_angle_pos(0) [ROTSET $mom_prev_alt_pos(3) $mom_prev_out_angle_pos(0) $mom_kin_4th_axis_direction $mom_kin_4th_axis_leader mom_sys_leader(fourth_axis)]
            set mom_out_angle_pos(1) [ROTSET $mom_prev_alt_pos(4) $mom_prev_out_angle_pos(1) $mom_kin_5th_axis_direction $mom_kin_5th_axis_leader mom_sys_leader(fourth_axis)]
            MOM_suppress once X Y Z
            PB_CMD_linear_move
            for {set i 0} {$i < 3} {incr i} {
               set mom_pos($i) [expr $mom_prev_alt_pos($i)+$mom_kin_reengage_distance*$mom_prev_tool_axis($i)]
            }
            MOM_suppress once fourth_axis fifth_axis
            PB_CMD_linear_move
            VMOV 3 mom_prev_alt_pos mom_pos
            MOM_suppress once fourth_axis fifth_axis
            if {$mom_feed_engage_value  > 0.0} {
               set mom_feed_rate $mom_feed_engage_value  
            } elseif {$mom_feed_cut_value  > 0.0} {
               set mom_feed_rate $mom_feed_cut_value  
            } else {
               set mom_feed_rate 10.0
            }
            FEEDRATE_SET
            PB_CMD_linear_move

            VMOV 5 save_pos mom_pos
            VMOV 5 save_prev_pos mom_prev_pos

            set mom_out_angle_pos(0) [ROTSET $mom_pos(3) $mom_out_angle_pos(0) $mom_kin_4th_axis_direction $mom_kin_4th_axis_leader mom_sys_leader(fourth_axis)]
            set mom_out_angle_pos(1) [ROTSET $mom_pos(4) $mom_out_angle_pos(1) $mom_kin_5th_axis_direction $mom_kin_5th_axis_leader mom_sys_leader(fourth_axis)]

            MOM_reload_variable -a mom_out_angle_pos
         }

         set save_feedrate $mom_feed_rate
         FEEDRATE_SET
      }
   }
}


if [info exists mom_sys_start_of_program_flag] {
   if [llength [info commands PB_CMD_kin_start_of_program] ] {
      PB_CMD_kin_start_of_program
   }
} else {
   set mom_sys_head_change_init_program 1
   set mom_sys_start_of_program_flag 1
}






#***************************
# Source in user's tcl file.
#***************************
 set user_tcl_file ${cam_post_dir}dmu_50_v_hh_user.tcl
 if { [file exists $user_tcl_file] } {
    source $user_tcl_file
 }


